#version 330 compatibility




/*
 _______ _________ _______  _______  _ 
(  ____ \\__   __/(  ___  )(  ____ )( )
| (    \/   ) (   | (   ) || (    )|| |
| (_____    | |   | |   | || (____)|| |
(_____  )   | |   | |   | ||  _____)| |
      ) |   | |   | |   | || (      (_)
/\____) |   | |   | (___) || )       _ 
\_______)   )_(   (_______)|/       (_)

Do not modify this code until you have read the LICENSE.txt contained in the root directory of this shaderpack!

*/





in vec4 texcoord;

in vec3 colorSunlight;
in vec3 colorSkylight;
in vec3 colorTorchlight;
in vec3 colorSkyUp;

in vec4 skySHR;
in vec4 skySHG;
in vec4 skySHB;

in vec3 worldLightVector;
in vec3 worldSunVector;

in float timeMidnight;

#include "lib/Uniforms.inc"
#include "lib/Common.inc"



/////////////////////////FUNCTIONS/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////FUNCTIONS/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////








vec2 GetNearFragment(vec2 coord, float depth, out float minDepth)
{
	
	
	vec2 texel = 1.0 / vec2(viewWidth, viewHeight);
	vec4 depthSamples;
	depthSamples.x = texture2D(depthtex1, coord + texel * vec2(1.0, 1.0)).x;
	depthSamples.y = texture2D(depthtex1, coord + texel * vec2(1.0, -1.0)).x;
	depthSamples.z = texture2D(depthtex1, coord + texel * vec2(-1.0, 1.0)).x;
	depthSamples.w = texture2D(depthtex1, coord + texel * vec2(-1.0, -1.0)).x;

	vec2 targetFragment = vec2(0.0, 0.0);

	if (depthSamples.x < depth)
		targetFragment = vec2(1.0, 1.0);
	if (depthSamples.y < depth)
		targetFragment = vec2(1.0, -1.0);
	if (depthSamples.z < depth)
		targetFragment = vec2(-1.0, 1.0);
	if (depthSamples.w < depth)
		targetFragment = vec2(-1.0, -1.0);


	minDepth = min(min(min(depthSamples.x, depthSamples.y), depthSamples.z), depthSamples.w);

	return coord + texel * targetFragment;
}






#include "lib/Materials.inc"
#include "lib/GBufferData.inc"




 int f(float v)
 {
   return int(floor(v));
 }
 int t(int v)
 {
   return v-f(mod(float(v),2.))-0;
 }
 int e(int v)
 {
   return v-f(mod(float(v),2.))-1;
 }
 int e()
 {
   ivec2 v=ivec2(viewWidth,viewHeight);
   int y=v.x*v.y;
   return t(f(floor(pow(float(y),.333333))));
 }
 int f()
 {
   ivec2 v=ivec2(2048,2048);
   int y=v.x*v.y;
   return e(f(floor(pow(float(y),.333333))));
 }
 vec3 v(vec2 v)
 {
   ivec2 f=ivec2(viewWidth,viewHeight);
   int x=f.x*f.y,y=e();
   ivec2 d=ivec2(v.x*f.x,v.y*f.y);
   float z=float(d.y/y),i=float(int(d.x+mod(f.x*z,y))/y);
   i+=floor(f.x*z/y);
   vec3 r=vec3(0.,0.,i);
   r.x=mod(d.x+mod(f.x*z,y),y);
   r.y=mod(d.y,y);
   r.xyz=floor(r.xyz);
   r/=y;
   r.xyz=r.xzy;
   return r;
 }
 vec2 s(vec3 v)
 {
   ivec2 f=ivec2(viewWidth,viewHeight);
   int z=e();
   vec3 i=v.xzy*z;
   i=floor(i+1e-05);
   float x=i.z;
   vec2 r;
   r.x=mod(i.x+x*z,f.x);
   float c=i.x+x*z;
   r.y=i.y+floor(c/f.x)*z;
   r+=.5;
   r/=f;
   return r;
 }
 vec3 d(vec2 v)
 {
   vec2 i=v;
   i.xy/=.5;
   ivec2 s=ivec2(2048,2048);
   int x=s.x*s.y,y=f();
   ivec2 d=ivec2(i.x*s.x,i.y*s.y);
   float z=float(d.y/y),r=float(int(d.x+mod(s.x*z,y))/y);
   r+=floor(s.x*z/y);
   vec3 m=vec3(0.,0.,r);
   m.x=mod(d.x+mod(s.x*z,y),y);
   m.y=mod(d.y,y);
   m.xyz=floor(m.xyz);
   m/=y;
   m.xyz=m.xzy;
   return m;
 }
 vec2 d(vec3 v,int y)
 {
   v=clamp(v,vec3(0.),vec3(1.));
   ivec2 f=ivec2(2048,2048);
   vec3 i=v.xzy*y;
   i=floor(i+1e-05);
   float x=i.z;
   vec2 r;
   r.x=mod(i.x+x*y,f.x);
   float c=i.x+x*y;
   r.y=i.y+floor(c/f.x)*y;
   r+=.5;
   r/=f;
   r.xy*=.5;
   return r;
 }
 vec3 e(vec3 v,int y)
 {
   return v*=1./y,v=v+vec3(.5),v=clamp(v,vec3(0.),vec3(1.)),v;
 }
 vec3 f(vec3 v,int y)
 {
   return v*=1./y,v=v+vec3(.5),v;
 }
 vec3 n(vec3 v)
 {
   int m=f();
   v=v-vec3(.5);
   v*=m;
   return v;
 }
 vec3 x(vec3 v)
 {
   int y=e();
   v*=1./y;
   v=v+vec3(.5);
   v=clamp(v,vec3(0.),vec3(1.));
   return v;
 }
 vec3 r(vec3 v)
 {
   int f=e();
   v=v-vec3(.5);
   v*=f;
   return v;
 }
 vec3 d()
 {
   vec3 v=cameraPosition.xyz+.5,i=previousCameraPosition.xyz+.5,y=floor(v-.0001),z=floor(i-.0001);
   return y-z;
 }
 vec3 m(vec3 v)
 {
   vec4 f=vec4(v,1.);
   f=shadowModelView*f;
   f=shadowProjection*f;
   f/=f.w;
   float x=sqrt(f.x*f.x+f.y*f.y),y=1.f-SHADOW_MAP_BIAS+x*SHADOW_MAP_BIAS;
   f.xy*=.95f/y;
   f.z=mix(f.z,.5,.8);
   f=f*.5f+.5f;
   f.xy*=.5;
   f.xy+=.5;
   return f.xyz;
 }
 vec3 d(vec3 v,vec3 f,vec2 i,vec2 y,vec4 d,vec4 s,inout float x,out vec2 r)
 {
   bool z=fract(v.x*2.)>.01&&fract(v.x*2.)<.99||fract(v.y*2.)>.01&&fract(v.y*2.)<.99||fract(v.z*2.)>.01&&fract(v.z*2.)<.99;
   z=!z;
   if(s.x==8||s.x==9||s.x==79||s.x<1.||!z||s.x==20.||s.x==171.||min(abs(f.x),abs(f.z))>.2)
     x=1.;
   if(s.x==50.||s.x==76.)
     {
       x=0.;
       if(f.y<.5)
         x=1.;
     }
   if(s.x==51)
     x=0.;
   vec3 c,t;
   if(f.x>.5)
     c=vec3(0.,0.,-1.),t=vec3(0.,-1.,0.);
   else
      if(f.x<-.5)
       c=vec3(0.,0.,1.),t=vec3(0.,-1.,0.);
     else
        if(f.y>.5)
         c=vec3(1.,0.,0.),t=vec3(0.,0.,1.);
       else
          if(f.y<-.5)
           c=vec3(1.,0.,0.),t=vec3(0.,0.,-1.);
         else
            if(f.z>.5)
             c=vec3(1.,0.,0.),t=vec3(0.,-1.,0.);
           else
              if(f.z<-.5)
               c=vec3(-1.,0.,0.),t=vec3(0.,-1.,0.);
   r=clamp((i.xy-y.xy)*100000.,vec2(0.),vec2(1.));
   float w=.15,n=.15;
   if(s.x==10.||s.x==11.)
     {
       if(abs(f.y)<.01&&z||f.y>.99)
         w=.1,n=.1,x=0.;
       else
          x=1.;
     }
   if(s.x==51)
     w=.5,n=.1;
   if(s.x==76)
     w=.2,n=.2;
   if(s.x-255.+39.>=103.&&s.x-255.+39.<=113.)
     n=.025,w=.025;
   c=normalize(d.xyz);
   t=normalize(cross(c,f.xyz)*sign(d.w));
   vec3 m=v.xyz+mix(c*w,-c*w,vec3(r.x));
   m.xyz+=mix(t*w,-t*w,vec3(r.y));
   m.xyz-=f.xyz*n;
   return m;
 }struct zdAtCTBXEz{vec3 ipiiYVkNiW;vec3 ipiiYVkNiWOrigin;vec3 yTinzyAggr;vec3 DagoLvaZQG;vec3 wPmXjhNUmn;vec3 HXMzbpgVIA;};
 zdAtCTBXEz p(Ray v)
 {
   zdAtCTBXEz f;
   f.ipiiYVkNiW=floor(v.origin);
   f.ipiiYVkNiWOrigin=f.ipiiYVkNiW;
   f.yTinzyAggr=abs(vec3(length(v.direction))/(v.direction+1e-07));
   f.DagoLvaZQG=sign(v.direction);
   f.wPmXjhNUmn=(sign(v.direction)*(f.ipiiYVkNiW-v.origin)+sign(v.direction)*.5+.5)*f.yTinzyAggr;
   f.HXMzbpgVIA=vec3(0.);
   return f;
 }
 void i(inout zdAtCTBXEz v)
 {
   v.HXMzbpgVIA=step(v.wPmXjhNUmn.xyz,v.wPmXjhNUmn.yzx)*step(v.wPmXjhNUmn.xyz,v.wPmXjhNUmn.zxy),v.wPmXjhNUmn+=v.HXMzbpgVIA*v.yTinzyAggr,v.ipiiYVkNiW+=v.HXMzbpgVIA*v.DagoLvaZQG;
 }
 void d(in Ray v,in vec3 f[2],out float i,out float y)
 {
   float z,x,r,t;
   i=(f[v.sign[0]].x-v.origin.x)*v.inv_direction.x;
   y=(f[1-v.sign[0]].x-v.origin.x)*v.inv_direction.x;
   z=(f[v.sign[1]].y-v.origin.y)*v.inv_direction.y;
   x=(f[1-v.sign[1]].y-v.origin.y)*v.inv_direction.y;
   r=(f[v.sign[2]].z-v.origin.z)*v.inv_direction.z;
   t=(f[1-v.sign[2]].z-v.origin.z)*v.inv_direction.z;
   i=max(max(i,z),r);
   y=min(min(y,x),t);
 }
 vec3 d(const vec3 v,const vec3 f,vec3 y)
 {
   const float x=1e-05;
   vec3 z=(f+v)*.5,i=(f-v)*.5,s=y-z,r=vec3(0.);
   r+=vec3(sign(s.x),0.,0.)*step(abs(abs(s.x)-i.x),x);
   r+=vec3(0.,sign(s.y),0.)*step(abs(abs(s.y)-i.y),x);
   r+=vec3(0.,0.,sign(s.z))*step(abs(abs(s.z)-i.z),x);
   return normalize(r);
 }
 bool e(const vec3 v,const vec3 f,Ray s,out vec2 i)
 {
   vec3 y=s.inv_direction*(v-s.origin),x=s.inv_direction*(f-s.origin),d=min(x,y),c=max(x,y);
   vec2 r=max(d.xx,d.yz);
   float z=max(r.x,r.y);
   r=min(c.xx,c.yz);
   float m=min(r.x,r.y);
   i.x=z;
   i.y=m;
   return m>max(z,0.);
 }
 bool d(const vec3 v,const vec3 f,Ray s,inout float y,inout vec3 x)
 {
   vec3 z=s.inv_direction*(v-1e-05-s.origin),i=s.inv_direction*(f+1e-05-s.origin),c=min(i,z),r=max(i,z);
   vec2 t=max(c.xx,c.yz);
   float m=max(t.x,t.y);
   t=min(r.xx,r.yz);
   float n=min(t.x,t.y);
   bool w=n>max(m,0.)&&max(m,0.)<y;
   if(w)
     x=d(v-1e-05,f+1e-05,s.origin+s.direction*m),y=m;
   return w;
 }
 vec3 e(vec3 v,vec3 f,vec3 y,vec3 z,int x)
 {
   if(rainStrength>.99)
     return vec3(0.);
   v+=1.;
   v-=Fract01(cameraPosition+.5);
   vec3 i=m(v);
   float w=.5;
   vec3 r=vec3(1.)*shadow2DLod(shadowtex0,vec3(i.xy,i.z-.0006*w),2).x;
   r*=saturate(dot(f,y));
   {
     vec4 s=texture2DLod(shadowcolor1,i.xy-vec2(0.,.5),4);
     float t=abs(s.x*256.-(v.y+cameraPosition.y)),c=GetCausticsComposite(v,f,t),n=shadow2DLod(shadowtex0,vec3(i.xy-vec2(0.,.5),i.z+1e-06),4).x;
     r=mix(r,r*c,1.-n);
   }
   r=TintUnderwaterDepth(r);
   return r*(1.-rainStrength);
 }
 vec3 f(vec3 v,vec3 f,vec3 y,vec3 z,int x)
 {
   if(rainStrength>.99)
     return vec3(0.);
   vec3 i=n(v),s=m(i+y*.99);
   float r=.5;
   vec3 t=vec3(1.)*shadow2DLod(shadowtex0,vec3(s.xy,s.z-.0006*r),3).x;
   t*=saturate(dot(f,y));
   t=TintUnderwaterDepth(t);
   #ifdef GI_SUNLIGHT_STAINED_GLASS_TINT
   float w=shadow2DLod(shadowtex0,vec3(s.xy-vec2(.5,0.),s.z-.0006*r),3).x;
   vec3 c=texture2DLod(shadowcolor,vec2(s.xy-vec2(.5,0.)),3).xyz;
   c*=c;
   t=mix(t,t*c,vec3(1.-w));
   #endif
   return t*(1.-rainStrength);
 }
 vec3 i(vec3 v,vec3 f,vec3 y,vec3 z,int x)
 {
   if(rainStrength>.99)
     return vec3(0.);
   v+=1.;
   v-=Fract01(cameraPosition+.5);
   vec3 i=m(v);
   float r=.5;
   vec3 t=vec3(1.)*shadow2DLod(shadowtex0,vec3(i.xy,i.z-.0006*r),2).x;
   t*=saturate(dot(f,y));
   t=TintUnderwaterDepth(t);
   #ifdef GI_SUNLIGHT_STAINED_GLASS_TINT
   float w=shadow2DLod(shadowtex0,vec3(i.xy-vec2(.5,0.),i.z-.0006*r),3).x;
   vec3 s=texture2DLod(shadowcolor,vec2(i.xy-vec2(.5,0.)),3).xyz;
   s*=s;
   t=mix(t,t*s,vec3(1.-w));
   #endif
   return t*(1.-rainStrength);
 }struct veHQsJlbTL{float nnNEIJGkdr;float KFTSJGnGnw;float ofqplrivFA;float WMbBZukiRr;vec3 JWRqQQkOhM;};
 vec4 h(veHQsJlbTL v)
 {
   vec4 f;
   v.JWRqQQkOhM=max(vec3(0.),v.JWRqQQkOhM);
   f.x=v.nnNEIJGkdr;
   v.JWRqQQkOhM=pow(v.JWRqQQkOhM,vec3(.125));
   f.y=PackTwo16BitTo32Bit(v.JWRqQQkOhM.x,v.ofqplrivFA);
   f.z=PackTwo16BitTo32Bit(v.JWRqQQkOhM.y,v.WMbBZukiRr);
   f.w=PackTwo16BitTo32Bit(v.JWRqQQkOhM.z,v.KFTSJGnGnw);
   return f;
 }
 veHQsJlbTL w(vec4 v)
 {
   veHQsJlbTL f;
   vec2 s=UnpackTwo16BitFrom32Bit(v.y),i=UnpackTwo16BitFrom32Bit(v.z),t=UnpackTwo16BitFrom32Bit(v.w);
   f.nnNEIJGkdr=v.x;
   f.ofqplrivFA=s.y;
   f.WMbBZukiRr=i.y;
   f.KFTSJGnGnw=t.y;
   f.JWRqQQkOhM=pow(vec3(s.x,i.x,t.x),vec3(8.));
   return f;
 }
 veHQsJlbTL G(vec2 v)
 {
   vec2 z=1./vec2(viewWidth,viewHeight),y=vec2(viewWidth,viewHeight);
   v=(floor(v*y)+.5)*z;
   return w(texture2DLod(colortex5,v,0));
 }
 float G(float v,float y)
 {
   float z=1.;
   #ifdef FULL_RT_REFLECTIONS
   z=clamp(pow(v,.125)+y,0.,1.);
   #else
   z=clamp(v*10.-7.,0.,1.);
   #endif
   return z;
 }
 bool G(vec3 v,float y,Ray f,bool z,inout float i,inout vec3 t)
 {
   bool r=false,m=false;
   #if RAYTRACE_GEOMETRY_QUALITY==0
   if(z)
     return false;
   if(y>=67.)
     return false;
   m=d(v,v+vec3(1.,1.,1.),f,i,t);
   r=m;
   #else
   if(y<40.)
     return m=d(v,v+vec3(1.,1.,1.),f,i,t),m;
   if(y==40.||y==41.||y>=43.&&y<=54.)
     {
       float x=.5;
       if(y==41.)
         x=.9375;
       m=d(v+vec3(0.,0.,0.),v+vec3(1.,x,1.),f,i,t);
       r=r||m;
     }
   if(y==42.||y>=55.&&y<=66.)
     m=d(v+vec3(0.,.5,0.),v+vec3(1.,1.,1.),f,i,t),r=r||m;
   if(y==43.||y==46.||y==47.||y==52.||y==53.||y==54.||y==55.||y==58.||y==59.||y==64.||y==65.||y==66.)
     {
       float x=.5;
       if(y==55.||y==58.||y==59.||y==64.||y==65.||y==66.)
         x=0.;
       m=d(v+vec3(0.,x,0.),v+vec3(.5,.5+x,.5),f,i,t);
       r=r||m;
     }
   if(y==43.||y==45.||y==48.||y==51.||y==53.||y==54.||y==55.||y==57.||y==60.||y==63.||y==65.||y==66.)
     {
       float x=.5;
       if(y==55.||y==57.||y==60.||y==63.||y==65.||y==66.)
         x=0.;
       m=d(v+vec3(.5,x,0.),v+vec3(1.,.5+x,.5),f,i,t);
       r=r||m;
     }
   if(y==44.||y==45.||y==49.||y==51.||y==52.||y==54.||y==56.||y==57.||y==61.||y==63.||y==64.||y==66.)
     {
       float x=.5;
       if(y==56.||y==57.||y==61.||y==63.||y==64.||y==66.)
         x=0.;
       m=d(v+vec3(.5,x,.5),v+vec3(1.,.5+x,1.),f,i,t);
       r=r||m;
     }
   if(y==44.||y==46.||y==50.||y==51.||y==52.||y==53.||y==56.||y==58.||y==62.||y==63.||y==64.||y==65.)
     {
       float x=.5;
       if(y==56.||y==58.||y==62.||y==63.||y==64.||y==65.)
         x=0.;
       m=d(v+vec3(0.,x,.5),v+vec3(.5,.5+x,1.),f,i,t);
       r=r||m;
     }
   if(y>=67.&&y<=82.)
     m=d(v+vec3(6.,0.,6.)/16.,v+vec3(10.,16.,10.)/16.,f,i,t),r=r||m;
   if(y==68.||y==69.||y==70.||y==72.||y==73.||y==74.||y==76.||y==77.||y==78.||y==80.||y==81.||y==82.)
     {
       float x=8.,c=8.;
       if(y==68.||y==70.||y==72.||y==74.||y==76.||y==78.||y==80.||y==82.)
         x=0.;
       if(y==69.||y==70.||y==73.||y==74.||y==77.||y==78.||y==81.||y==82.)
         c=16.;
       m=d(v+vec3(x,6.,7.)/16.,v+vec3(c,9.,9.)/16.,f,i,t);
       r=r||m;
       m=d(v+vec3(x,12.,7.)/16.,v+vec3(c,15.,9.)/16.,f,i,t);
       r=r||m;
     }
   if(y>=71.&&y<=82.)
     {
       float x=8.,c=8.;
       if(y>=71.&&y<=74.||y>=79.&&y<=82.)
         c=16.;
       if(y>=75.&&y<=82.)
         x=0.;
       m=d(v+vec3(7.,6.,x)/16.,v+vec3(9.,9.,c)/16.,f,i,t);
       r=r||m;
       m=d(v+vec3(7.,12.,x)/16.,v+vec3(9.,15.,c)/16.,f,i,t);
       r=r||m;
     }
   #if RAYTRACE_GEOMETRY_QUALITY==2
   if(y>=83.&&y<=86.)
     {
       vec3 x=vec3(0),c=vec3(0);
       if(y==83.)
         x=vec3(0,0,0),c=vec3(16,16,3);
       if(y==84.)
         x=vec3(0,0,13),c=vec3(16,16,16);
       if(y==86.)
         x=vec3(0,0,0),c=vec3(3,16,16);
       if(y==85.)
         x=vec3(13,0,0),c=vec3(16,16,16);
       m=d(v+x/16.,v+c/16.,f,i,t);
       r=r||m;
     }
   if(y>=87.&&y<=102.)
     {
       vec3 x=vec3(0.),c=vec3(1.);
       if(y>=87.&&y<=94.)
         {
           float w=0.;
           if(y>=91.&&y<=94.)
             w=13.;
           x=vec3(0.,w,0.)/16.;
           c=vec3(16.,w+3.,16.)/16.;
         }
       if(y>=95.&&y<=98.)
         {
           float w=13.;
           if(y==97.||y==98.)
             w=0.;
           x=vec3(0.,0.,w)/16.;
           c=vec3(16.,16.,w+3.)/16.;
         }
       if(y>=99.&&y<=102.)
         {
           float s=13.;
           if(y==99.||y==100.)
             s=0.;
           x=vec3(s,0.,0.)/16.;
           c=vec3(s+3.,16.,16.)/16.;
         }
       m=d(v+x,v+c,f,i,t);
       r=r||m;
     }
   if(y>=103.&&y<=113.)
     {
       vec3 x=vec3(0.),s=vec3(1.);
       if(y>=103.&&y<=110.)
         {
           float c=float(y)-float(103.)+1.;
           s.y=c*2./16.;
         }
       if(y==111.)
         s.y=.0625;
       if(y==112.)
         x=vec3(1.,0.,1.)/16.,s=vec3(15.,1.,15.)/16.;
       if(y==113.)
         x=vec3(1.,0.,1.)/16.,s=vec3(15.,.5,15.)/16.;
       m=d(v+x,v+s,f,i,t);
       r=r||m;
     }
   #endif
   #endif
   return r;
 }
 vec2 g(inout float v)
 {
   return fract(sin(vec2(v+=.1,v+=.1))*vec2(43758.5,22578.1));
 }
 vec3 c(vec2 v)
 {
   vec2 y=vec2(v.xy*vec2(viewWidth,viewHeight))/64.;
   const vec2 f[16]=vec2[16](vec2(-1,-1),vec2(0,-.333333),vec2(-.5,.333333),vec2(.5,-.777778),vec2(-.75,-.111111),vec2(.25,.555556),vec2(-.25,-.555556),vec2(.75,.111111),vec2(-.875,.777778),vec2(.125,-.925926),vec2(-.375,-.259259),vec2(.625,.407407),vec2(-.625,-.703704),vec2(.375,-.037037),vec2(-.125,.62963),vec2(.875,-.481482));
   y+=f[int(mod(float(frameCounter),16.))]*.5;
   y=(floor(y*64.)+.5)/64.;
   vec3 x=texture2D(noisetex,y).xyz;
   return x;
 }
 vec3 G(vec3 v,inout float y,int z)
 {
   vec2 f=c(texcoord.xy+vec2(y+=.1,y+=.1)).xy;
   f=fract(f+g(y)*.1);
   float x=6.28319*f.x,i=sqrt(f.y);
   vec3 t=normalize(cross(v,vec3(0.,1.,1.))),r=cross(v,t),m=t*cos(x)*i+r*sin(x)*i+v.xyz*sqrt(1.-f.y);
   return m;
 }
 vec3 c(vec3 v,vec3 y)
 {
   vec2 f=s(x(n(v)+y+1.));
   vec3 z=G(f).JWRqQQkOhM;
   return z;
 }
 vec3 G()
 {
   vec2 y=s(v(texcoord.xy)+d()/e());
   vec3 x=G(y).JWRqQQkOhM;
   return x;
 }
 vec3 G(float v,float f,float x,vec3 y)
 {
   vec3 r;
   r.x=x*cos(v);
   r.y=x*sin(v);
   r.z=f;
   vec3 z=abs(y.y)<.999?vec3(0,0,1):vec3(1,0,0),i=normalize(cross(y,vec3(0.,1.,1.))),t=cross(i,y);
   return i*r.x+t*r.y+y*r.z;
 }
 vec3 c(vec2 v,float y,vec3 t)
 {
   float x=2*3.14159*v.x,z=sqrt((1-v.y)/(1+(y*y-1)*v.y)),i=sqrt(1-z*z);
   return G(x,z,i,t);
 }
 float l(float v)
 {
   return 2./(v*v+1e-07)-2.;
 }
 vec3 e(in vec2 v,in float y,in vec3 t)
 {
   float x=l(y),f=2*3.14159*v.x,z=pow(v.y,1.f/(x+1.f)),i=sqrt(1-z*z);
   return G(f,z,i,t);
 }
 float g(float v,float y)
 {
   return 1./(v*(1.-y)+y);
 }
 void h(inout vec3 v,in vec3 y)
 {
   vec3 x=normalize(y.xyz),f=v;
   float z=dot(f,x);
   f=normalize(v-x*saturate(z)*.5);
   v=f;
 }
 vec4 R(in vec2 v)
 {
   float y=GetDepth(v);
   vec4 f=gbufferProjectionInverse*vec4(v.x*2.f-1.f,v.y*2.f-1.f,2.f*y-1.f,1.f);
   f/=f.w;
   return f;
 }
 vec4 R(in vec2 v,in float y)
 {
   vec4 f=gbufferProjectionInverse*vec4(v.x*2.f-1.f,v.y*2.f-1.f,2.f*y-1.f,1.f);
   f/=f.w;
   return f;
 }
 void G(inout vec3 v,in vec3 y,in vec3 f,vec3 x,float z)
 {
   float r=length(y);
   r*=pow(eyeBrightnessSmooth.y/240.f,6.f);
   r*=rainStrength;
   float i=pow(exp(-r*1e-05),4.);
   i=max(i,.5);
   vec3 c=vec3(dot(colorSkyUp,vec3(1.)))*.05;
   v=mix(c,v,vec3(i));
 }
 vec4 G(float v,float y,vec3 s,vec3 t,vec3 x,vec3 z,vec3 r,float w,float n)
 {
   float m=1.;
   #ifdef SUNLIGHT_LEAK_FIX
   if(isEyeInWater<1)
     m=saturate(n*100.);
   #endif
   v=max(v-.05,0.);
   y=0.;
   float h=v*v,o=fract(frameCounter*.0123456);
   vec3 R=c(texcoord.xy).xyz*.99+.005,a=c(texcoord.xy+.1).xyz,l=reflect(r,c(c(texcoord.xy).xy*vec2(1.,.8),h,x)),M=normalize((gbufferModelView*vec4(l.xyz,0.)).xyz);
   if(dot(l,x)<0.)
     l=reflect(l,x);
   #ifdef REFLECTION_SCREEN_SPACE_TRACING
   bool g=false;
   {
     const int A=16;
     vec2 b=texcoord.xy;
     vec3 T=t.xyz;
     float W=0.;
     vec3 D=t.xyz;
     float P=.1/saturate(dot(-r,x)+.001),U=P*2.,k=1.,Y=0.;
     for(int N=0;N<A;N++)
       {
         float S=float(N),u=(S+.5)/float(A);
         vec3 F=M.xyz*P*(.1+length(D)*.1)*k;
         float H=U*(length(D)*.1);
         D+=F;
         vec2 C=ProjectBack(D).xy;
         vec3 E=GetViewPosition(C.xy,GetDepth(C.xy)).xyz;
         float J=length(D)-length(E)-.02;
         if(D.z>0.)
           {
             break;
           }
         if(J>0.&&J<H&&C.x>0.&&C.x<1.&&C.y>0.&&C.y<1.)
           {
             D-=F;
             k*=.5;
             Y+=1.;
             if(Y>2.)
               {
                 g=true;
                 b=C.xy;
                 T=E.xyz;
                 W=distance(D,t.xyz)*.4;
                 break;
               }
           }
       }
     vec3 N=(gbufferModelViewInverse*vec4(T,0.)).xyz;
     if(length(N)>far)
       g=false;
     if(g)
       {
         b.xy=floor(b.xy*vec2(viewWidth,viewHeight)+.5)/vec2(viewWidth,viewHeight);
         TemporalJitterProjPos01(b);
         vec3 F=pow(texture2DLod(colortex3,b.xy,0).xyz,vec3(2.2)),C=F*100.;
         LandAtmosphericScattering(C,T,M,l,worldSunVector,1.);
         G(C,T,normalize(t.xyz),normalize(s.xyz),1.);
         UnderwaterFog(C,length(T),r,colorSkyUp,colorSunlight);
         return vec4(C,saturate(W/4.));
       }
   }
   #endif
   int D=f(),T=e();
   vec3 C=s+x*(.01+w*.1);
   C+=Fract01(cameraPosition.xyz+.5);
   Ray b=MakeRay(e(C,D)*D-vec3(1.),l);
   vec3 A=vec3(1.),W=vec3(0.);
   float N=0.;
   zdAtCTBXEz F=p(b);
   float Y=far;
   vec3 S=vec3(1.);
   for(int J=0;J<1;J++)
     {
       vec4 U=vec4(0.);
       vec3 E=vec3(0.);
       float P=.5;
       for(int k=0;k<REFLECTION_TRACE_LENGTH;k++)
         {
           E=F.ipiiYVkNiW/float(D);
           vec2 H=d(E,D);
           U=texture2DLod(shadowcolor,H,0);
           N=U.w*255.;
           float u=1.-step(.5,abs(N-241.));
           vec3 K=U.xyz;
           float L=dot(F.ipiiYVkNiW+.5-b.origin,F.ipiiYVkNiW+.5-b.origin),I=saturate(pow(saturate(dot(b.direction,normalize(F.ipiiYVkNiW+.5-b.origin))),56.*L)*5.-1.)*5.;
           W+=K*u*P*.5*I;
           if(N<240.)
             {
               if(G(F.ipiiYVkNiW,N,b,k==0,Y,S))
                 {
                   break;
                 }
             }
           i(F);
           P=1.;
         }
       if(U.w*255.<1.f||U.w*255.>254.f)
         {
           vec3 k=SkyShading(b.direction,worldSunVector,rainStrength);
           k=DoNightEyeAtNight(k*12.,timeMidnight)*.083333;
           k=TintUnderwaterDepth(k);
           vec3 H=k*A;
           #ifdef CLOUDS_IN_REFLECTIONS
           CloudPlane(H,-b.direction,worldLightVector,colorSunlight,colorSkyUp,H,timeMidnight,false);
           #endif
           W+=H*.1;
           Y=1000.;
           break;
         }
       vec3 k=mod(b.origin+b.direction*Y,vec3(1.))-.5;
       float H=log2(Y*.4*v*TEXTURE_RESOLUTION);
       vec2 u=vec2(0.);
       u+=vec2(k.z*-S.x,-k.y)*abs(S.x);
       u+=vec2(k.x,k.z*S.y)*abs(S.y);
       u+=vec2(k.x*S.z,-k.y)*abs(S.z);
       vec3 K=(b.origin+b.direction*Y)/float(D);
       vec2 L=textureSize(colortex0,0);
       vec4 I=texture2DLod(shadowcolor1,d(E,D),0);
       vec2 V=I.xy;
       V=(floor(V*L/TEXTURE_RESOLUTION)+.5)/(L/TEXTURE_RESOLUTION);
       vec2 Q=V+u.xy*(TEXTURE_RESOLUTION/L);
       vec3 O=pow(texture2DLod(colortex0,Q,H).xyz,vec3(2.2));
       O*=mix(vec3(1.),U.xyz/(I.w+1e-05),vec3(I.z));
       if(N<240.)
         {
           vec3 B=saturate(U.xyz);
           A*=O;
         }
       if(abs(N-31.)<.1)
         W+=.09*A*GI_LIGHT_BLOCK_INTENSITY;
       if(Y*v>.2)
         {
           vec3 B=vec3(1.)-abs(S);
           W+=c(E+(k+(a.xyz-.5)*2.)/float(D)*B,S)*A;
         }
       else
         {
           vec3 B=vec3(0.),X=vec3(0.);
           if(abs(S.x)>.5)
             B=vec3(0.,1.,0.),X=vec3(0.,0.,1.);
           if(abs(S.y)>.5)
             B=vec3(1.,0.,0.),X=vec3(0.,0.,1.);
           if(abs(S.z)>.5)
             B=vec3(1.,0.,0.),X=vec3(0.,1.,0.);
           B*=1.;
           X*=1.;
           vec3 q=c(E,S),j=q,Z=saturate(q*100000.),ab=c(E+B/float(D),S);
           j+=ab;
           Z+=saturate(ab*100000.);
           vec3 ac=c(E-B/float(D),S);
           j+=ac;
           Z+=saturate(ac*100000.);
           vec3 ad=c(E+X/float(D),S);
           j+=ad;
           Z+=saturate(ad*100000.);
           vec3 ae=c(E-X/float(D),S);
           j+=ae;
           Z+=saturate(ae*100000.);
           j/=Z+vec3(.0001);
           W+=j*A;
         }
       const float B=2.4;
       vec3 X=e(C+b.direction*Y-1.,worldLightVector,S,l,D)*A*B*colorSunlight*m;
       if(isEyeInWater>0)
         ;
       W+=X;
     }
   vec3 k=t.xyz+M*Y,E=(gbufferModelViewInverse*vec4(k.xyz,0.)).xyz;
   if(Y<1000.)
     LandAtmosphericScattering(W,k,M,l,worldSunVector,1.);
   G(W,k,normalize(t.xyz),normalize(s.xyz),1.);
   UnderwaterFog(W,length(E),r,colorSkyUp,colorSunlight);
   Y*=saturate(dot(-r,x))*2.;
   return vec4(W,saturate(Y/4.));
 }
 vec4 T(float v)
 {
   float y=v*v,f=y*v;
   vec4 r;
   r.x=-f+3*y-3*v+1;
   r.y=3*f-6*y+4;
   r.z=-3*f+3*y+3*v+1;
   r.w=f;
   return r/6.f;
 }
 vec4 T(in sampler2D v,in vec2 f)
 {
   vec2 y=vec2(viewWidth,viewHeight);
   f*=y;
   f-=.5;
   float x=fract(f.x),t=fract(f.y);
   f.x-=x;
   f.y-=t;
   vec4 i=T(x),r=T(t),m=vec4(f.x-.5,f.x+1.5,f.y-.5,f.y+1.5),s=vec4(i.x+i.y,i.z+i.w,r.x+r.y,r.z+r.w),c=m+vec4(i.y,i.w,r.y,r.w)/s,z=texture2DLod(v,vec2(c.x,c.z)/y,0),w=texture2DLod(v,vec2(c.y,c.z)/y,0),n=texture2DLod(v,vec2(c.x,c.w)/y,0),d=texture2DLod(v,vec2(c.y,c.w)/y,0);
   float D=s.x/(s.x+s.y),S=s.z/(s.z+s.w);
   return mix(mix(d,n,D),mix(w,z,D),S);
 }
 bool i(vec3 v,vec3 y)
 {
   vec3 x=normalize(cross(dFdx(v),dFdy(v))),t=normalize(y-v),i=normalize(t);
   return distance(v,y)<.05;
 }
 vec3 y(vec2 v)
 {
   vec2 y=vec2(viewWidth,viewHeight),x=1./y,f=v*y,i=floor(f-.5)+.5,t=f-i,z=t*t,r=t*z;
   float m=.5;
   vec2 s=-m*r+2.*m*z-m*t,c=(2.-m)*r-(3.-m)*z+1.,w=-(2.-m)*r+(3.-2.*m)*z+m*t,d=m*r-m*z,n=c+w,S=x*(i+w/n);
   vec3 a=texture2DLod(colortex4,vec2(S.x,S.y),0).xyz;
   vec2 k=x*(i-1.),b=x*(i+2.);
   vec4 D=vec4(texture2DLod(colortex4,vec2(S.x,k.y),0).xyz,1.)*(n.x*s.y)+vec4(texture2DLod(colortex4,vec2(k.x,S.y),0).xyz,1.)*(s.x*n.y)+vec4(a,1.)*(n.x*n.y)+vec4(texture2DLod(colortex4,vec2(b.x,S.y),0).xyz,1.)*(d.x*n.y)+vec4(texture2DLod(colortex4,vec2(S.x,b.y),0).xyz,1.)*(n.x*d.y);
   return max(vec3(0.),D.xyz*(1./D.w));
 }
 void main()
 {
   GBufferData v=GetGBufferData();
   GBufferDataTransparent y=GetGBufferDataTransparent();
   MaterialMask f=CalculateMasks(v.materialID),i=CalculateMasks(y.materialID);
   bool x=y.depth<v.depth;
   if(x)
     v.depth=y.depth,v.normal=y.normal,v.smoothness=y.smoothness,v.metalness=0.,v.mcLightmap=y.mcLightmap,i.sky=0.;
   vec4 r=GetViewPosition(texcoord.xy,v.depth),s=gbufferModelViewInverse*vec4(r.xyz,1.),t=gbufferModelViewInverse*vec4(r.xyz,0.);
   vec3 z=normalize(r.xyz),c=normalize(t.xyz),n=normalize((gbufferModelViewInverse*vec4(v.normal,0.)).xyz),w=normalize((gbufferModelViewInverse*vec4(v.geoNormal,0.)).xyz);
   float m=length(r.xyz);
   vec4 a=vec4(0.);
   float d=G(v.smoothness,v.metalness);
   if(d>.0001&&i.sky<.5)
     a=G(1.-v.smoothness,v.metalness,s.xyz,r.xyz,n.xyz,w,c.xyz,f.leaves,v.mcLightmap.y);
   vec4 k=texture2DLod(colortex3,texcoord.xy,0);
   vec3 b=k.xyz;
   b.xyz=pow(b.xyz,vec3(2.2));
   if(x)
     {
       vec3 S=GetViewPosition(texcoord.xy,texture2DLod(depthtex1,texcoord.xy,0).x).xyz;
       float e=length(S.xyz),D=e-m;
       vec3 C=y.normal-y.geoNormal*1.05;
       float A=saturate(D*.5);
       vec2 l=texcoord.xy+C.xy/(m+1.5)*A;
       {
         float p=ExpToLinearDepth(texture2DLod(depthtex1,l,0).x),E=ExpToLinearDepth(texture2DLod(depthtex0,l,0).x);
         if(E>=p)
           l=texcoord.xy;
       }
       b.xyz=pow(texture2DLod(colortex3,l.xy,0).xyz,vec3(2.2));
       S=GetViewPosition(l.xy,texture2DLod(depthtex1,l.xy,0).x).xyz;
       r=GetViewPosition(l.xy,texture2DLod(depthtex0,l.xy,0).x);
       e=length(S.xyz);
       m=length(r.xyz);
       D=e-m;
       if(i.water>.5&&isEyeInWater<1)
         {
           b.xyz*=exp(GetWaterAbsorption()*-D);
           vec3 E=GetWaterFogColor()*.001;
           E*=exp(-GetWaterAbsorption()*((-c.y*.5+.5)*3.));
           E*=pow(curve(saturate(mix(c.y,1.,.5))),2.)*.6+.4;
           E*=(colorSkyUp+colorSunlight*2.)*1.4;
           E=TintUnderwaterDepth(E);
           float N=exp(-D*.03);
           E*=exp(-GetWaterAbsorption()*(1.-N)*20.);
           E*=eyeBrightnessSmooth.y/240.;
           b=mix(E,b,vec3(N));
         }
       if(i.stainedGlass>.5)
         {
           vec3 h=normalize(y.albedo.xyz+.0001)*pow(length(y.albedo.xyz),.5);
           b.xyz*=mix(vec3(1.),h,vec3(pow(y.albedo.w,.2)));
           b.xyz*=mix(vec3(1.),h,vec3(pow(y.albedo.w,.2)));
         }
     }
   b.xyz=pow(b.xyz,vec3(1./2.2));
   gl_FragData[0]=texture2DLod(colortex0,texcoord.xy,0);
   gl_FragData[1]=vec4(b.xyz,v.smoothness);
   gl_FragData[2]=a*vec4(vec3(.1),1.);
 };




/* DRAWBUFFERS:036 */
