#version 330 compatibility




/*
 _______ _________ _______  _______  _ 
(  ____ \\__   __/(  ___  )(  ____ )( )
| (    \/   ) (   | (   ) || (    )|| |
| (_____    | |   | |   | || (____)|| |
(_____  )   | |   | |   | ||  _____)| |
      ) |   | |   | |   | || (      (_)
/\____) |   | |   | (___) || )       _ 
\_______)   )_(   (_______)|/       (_)

Do not modify this code until you have read the LICENSE.txt contained in the root directory of this shaderpack!

*/


#include "lib/Uniforms.inc"
#include "lib/Common.inc"





in vec4 texcoord;
in vec3 lightVector;

in float timeSunriseSunset;
in float timeNoon;
in float timeMidnight;
in float timeSkyDark;

in vec3 colorSunlight;
in vec3 colorSkylight;
in vec3 colorSunglow;
in vec3 colorBouncedSunlight;
in vec3 colorScatteredSunlight;
in vec3 colorTorchlight;
in vec3 colorWaterMurk;
in vec3 colorWaterBlue;
in vec3 colorSkyTint;



in vec3 upVector;



#include "lib/GBufferData.inc"


 int f(float v)
 {
   return int(floor(v));
 }
 int t(int v)
 {
   return v-f(mod(float(v),2.))-0;
 }
 int d(int v)
 {
   return v-f(mod(float(v),2.))-1;
 }
 int d()
 {
   ivec2 v=ivec2(viewWidth,viewHeight);
   int y=v.x*v.y;
   return t(f(floor(pow(float(y),.333333))));
 }
 int f()
 {
   ivec2 v=ivec2(2048,2048);
   int y=v.x*v.y;
   return d(f(floor(pow(float(y),.333333))));
 }
 vec3 n(vec2 v)
 {
   ivec2 f=ivec2(viewWidth,viewHeight);
   int x=f.x*f.y,y=d();
   ivec2 n=ivec2(v.x*f.x,v.y*f.y);
   float z=float(n.y/y),i=float(int(n.x+mod(f.x*z,y))/y);
   i+=floor(f.x*z/y);
   vec3 m=vec3(0.,0.,i);
   m.x=mod(n.x+mod(f.x*z,y),y);
   m.y=mod(n.y,y);
   m.xyz=floor(m.xyz);
   m/=y;
   m.xyz=m.xzy;
   return m;
 }
 vec2 s(vec3 v)
 {
   ivec2 f=ivec2(viewWidth,viewHeight);
   int x=d();
   vec3 i=v.xzy*x;
   i=floor(i+1e-05);
   float y=i.z;
   vec2 n;
   n.x=mod(i.x+y*x,f.x);
   float s=i.x+y*x;
   n.y=i.y+floor(s/f.x)*x;
   n+=.5;
   n/=f;
   return n;
 }
 vec3 x(vec2 v)
 {
   vec2 i=v;
   i.xy/=.5;
   ivec2 m=ivec2(2048,2048);
   int x=m.x*m.y,y=f();
   ivec2 n=ivec2(i.x*m.x,i.y*m.y);
   float z=float(n.y/y),r=float(int(n.x+mod(m.x*z,y))/y);
   r+=floor(m.x*z/y);
   vec3 s=vec3(0.,0.,r);
   s.x=mod(n.x+mod(m.x*z,y),y);
   s.y=mod(n.y,y);
   s.xyz=floor(s.xyz);
   s/=y;
   s.xyz=s.xzy;
   return s;
 }
 vec2 d(vec3 v,int y)
 {
   v=clamp(v,vec3(0.),vec3(1.));
   ivec2 f=ivec2(2048,2048);
   vec3 i=v.xzy*y;
   i=floor(i+1e-05);
   float x=i.z;
   vec2 n;
   n.x=mod(i.x+x*y,f.x);
   float s=i.x+x*y;
   n.y=i.y+floor(s/f.x)*y;
   n+=.5;
   n/=f;
   n.xy*=.5;
   return n;
 }
 vec3 f(vec3 v,int y)
 {
   return v*=1./y,v=v+vec3(.5),v=clamp(v,vec3(0.),vec3(1.)),v;
 }
 vec3 n(vec3 v,int y)
 {
   return v*=1./y,v=v+vec3(.5),v;
 }
 vec3 v(vec3 v)
 {
   int m=f();
   v=v-vec3(.5);
   v*=m;
   return v;
 }
 vec3 e(vec3 v)
 {
   int y=d();
   v*=1./y;
   v=v+vec3(.5);
   v=clamp(v,vec3(0.),vec3(1.));
   return v;
 }
 vec3 r(vec3 v)
 {
   int m=d();
   v=v-vec3(.5);
   v*=m;
   return v;
 }
 vec3 e()
 {
   vec3 v=cameraPosition.xyz+.5,f=previousCameraPosition.xyz+.5,y=floor(v-.0001),x=floor(f-.0001);
   return y-x;
 }
 vec3 m(vec3 v)
 {
   vec4 f=vec4(v,1.);
   f=shadowModelView*f;
   f=shadowProjection*f;
   f/=f.w;
   float x=sqrt(f.x*f.x+f.y*f.y),y=1.f-SHADOW_MAP_BIAS+x*SHADOW_MAP_BIAS;
   f.xy*=.95f/y;
   f.z=mix(f.z,.5,.8);
   f=f*.5f+.5f;
   f.xy*=.5;
   f.xy+=.5;
   return f.xyz;
 }
 vec3 d(vec3 v,vec3 f,vec2 n,vec2 y,vec4 i,vec4 m,inout float x,out vec2 z)
 {
   bool r=fract(v.x*2.)>.01&&fract(v.x*2.)<.99||fract(v.y*2.)>.01&&fract(v.y*2.)<.99||fract(v.z*2.)>.01&&fract(v.z*2.)<.99;
   r=!r;
   if(m.x==8||m.x==9||m.x==79||m.x<1.||!r||m.x==20.||m.x==171.||min(abs(f.x),abs(f.z))>.2)
     x=1.;
   if(m.x==50.||m.x==76.)
     {
       x=0.;
       if(f.y<.5)
         x=1.;
     }
   if(m.x==51)
     x=0.;
   vec3 s,c;
   if(f.x>.5)
     s=vec3(0.,0.,-1.),c=vec3(0.,-1.,0.);
   else
      if(f.x<-.5)
       s=vec3(0.,0.,1.),c=vec3(0.,-1.,0.);
     else
        if(f.y>.5)
         s=vec3(1.,0.,0.),c=vec3(0.,0.,1.);
       else
          if(f.y<-.5)
           s=vec3(1.,0.,0.),c=vec3(0.,0.,-1.);
         else
            if(f.z>.5)
             s=vec3(1.,0.,0.),c=vec3(0.,-1.,0.);
           else
              if(f.z<-.5)
               s=vec3(-1.,0.,0.),c=vec3(0.,-1.,0.);
   z=clamp((n.xy-y.xy)*100000.,vec2(0.),vec2(1.));
   float h=.15,w=.15;
   if(m.x==10.||m.x==11.)
     {
       if(abs(f.y)<.01&&r||f.y>.99)
         h=.1,w=.1,x=0.;
       else
          x=1.;
     }
   if(m.x==51)
     h=.5,w=.1;
   if(m.x==76)
     h=.2,w=.2;
   if(m.x-255.+39.>=103.&&m.x-255.+39.<=113.)
     w=.025,h=.025;
   s=normalize(i.xyz);
   c=normalize(cross(s,f.xyz)*sign(i.w));
   vec3 d=v.xyz+mix(s*h,-s*h,vec3(z.x));
   d.xyz+=mix(c*h,-c*h,vec3(z.y));
   d.xyz-=f.xyz*w;
   return d;
 }struct zdAtCTBXEz{vec3 ipiiYVkNiW;vec3 ipiiYVkNiWOrigin;vec3 yTinzyAggr;vec3 DagoLvaZQG;vec3 wPmXjhNUmn;vec3 HXMzbpgVIA;};
 zdAtCTBXEz p(Ray v)
 {
   zdAtCTBXEz f;
   f.ipiiYVkNiW=floor(v.origin);
   f.ipiiYVkNiWOrigin=f.ipiiYVkNiW;
   f.yTinzyAggr=abs(vec3(length(v.direction))/(v.direction+1e-07));
   f.DagoLvaZQG=sign(v.direction);
   f.wPmXjhNUmn=(sign(v.direction)*(f.ipiiYVkNiW-v.origin)+sign(v.direction)*.5+.5)*f.yTinzyAggr;
   f.HXMzbpgVIA=vec3(0.);
   return f;
 }
 void w(inout zdAtCTBXEz v)
 {
   v.HXMzbpgVIA=step(v.wPmXjhNUmn.xyz,v.wPmXjhNUmn.yzx)*step(v.wPmXjhNUmn.xyz,v.wPmXjhNUmn.zxy),v.wPmXjhNUmn+=v.HXMzbpgVIA*v.yTinzyAggr,v.ipiiYVkNiW+=v.HXMzbpgVIA*v.DagoLvaZQG;
 }
 void d(in Ray v,in vec3 f[2],out float i,out float y)
 {
   float x,z,r,n;
   i=(f[v.sign[0]].x-v.origin.x)*v.inv_direction.x;
   y=(f[1-v.sign[0]].x-v.origin.x)*v.inv_direction.x;
   x=(f[v.sign[1]].y-v.origin.y)*v.inv_direction.y;
   z=(f[1-v.sign[1]].y-v.origin.y)*v.inv_direction.y;
   r=(f[v.sign[2]].z-v.origin.z)*v.inv_direction.z;
   n=(f[1-v.sign[2]].z-v.origin.z)*v.inv_direction.z;
   i=max(max(i,x),r);
   y=min(min(y,z),n);
 }
 vec3 d(const vec3 v,const vec3 f,vec3 y)
 {
   const float x=1e-05;
   vec3 z=(f+v)*.5,n=(f-v)*.5,i=y-z,r=vec3(0.);
   r+=vec3(sign(i.x),0.,0.)*step(abs(abs(i.x)-n.x),x);
   r+=vec3(0.,sign(i.y),0.)*step(abs(abs(i.y)-n.y),x);
   r+=vec3(0.,0.,sign(i.z))*step(abs(abs(i.z)-n.z),x);
   return normalize(r);
 }
 bool e(const vec3 v,const vec3 f,Ray m,out vec2 i)
 {
   vec3 y=m.inv_direction*(v-m.origin),x=m.inv_direction*(f-m.origin),n=min(x,y),s=max(x,y);
   vec2 r=max(n.xx,n.yz);
   float z=max(r.x,r.y);
   r=min(s.xx,s.yz);
   float c=min(r.x,r.y);
   i.x=z;
   i.y=c;
   return c>max(z,0.);
 }
 bool d(const vec3 v,const vec3 f,Ray m,inout float x,inout vec3 y)
 {
   vec3 z=m.inv_direction*(v-1e-05-m.origin),i=m.inv_direction*(f+1e-05-m.origin),n=min(i,z),s=max(i,z);
   vec2 r=max(n.xx,n.yz);
   float c=max(r.x,r.y);
   r=min(s.xx,s.yz);
   float G=min(r.x,r.y);
   bool t=G>max(c,0.)&&max(c,0.)<x;
   if(t)
     y=d(v-1e-05,f+1e-05,m.origin+m.direction*c),x=c;
   return t;
 }
 vec3 e(vec3 v,vec3 f,vec3 y,vec3 x,int z)
 {
   if(rainStrength>.99)
     return vec3(0.);
   v+=1.;
   v-=Fract01(cameraPosition+.5);
   vec3 i=m(v);
   float n=.5;
   vec3 r=vec3(1.)*shadow2DLod(shadowtex0,vec3(i.xy,i.z-.0006*n),2).x;
   r*=saturate(dot(f,y));
   {
     vec4 s=texture2DLod(shadowcolor1,i.xy-vec2(0.,.5),4);
     float c=abs(s.x*256.-(v.y+cameraPosition.y)),h=GetCausticsComposite(v,f,c),t=shadow2DLod(shadowtex0,vec3(i.xy-vec2(0.,.5),i.z+1e-06),4).x;
     r=mix(r,r*h,1.-t);
   }
   r=TintUnderwaterDepth(r);
   return r*(1.-rainStrength);
 }
 vec3 f(vec3 y,vec3 f,vec3 x,vec3 z,int n)
 {
   if(rainStrength>.99)
     return vec3(0.);
   vec3 i=v(y),s=m(i+x*.99);
   float r=.5;
   vec3 c=vec3(1.)*shadow2DLod(shadowtex0,vec3(s.xy,s.z-.0006*r),3).x;
   c*=saturate(dot(f,x));
   c=TintUnderwaterDepth(c);
   #ifdef GI_SUNLIGHT_STAINED_GLASS_TINT
   float t=shadow2DLod(shadowtex0,vec3(s.xy-vec2(.5,0.),s.z-.0006*r),3).x;
   vec3 h=texture2DLod(shadowcolor,vec2(s.xy-vec2(.5,0.)),3).xyz;
   h*=h;
   c=mix(c,c*h,vec3(1.-t));
   #endif
   return c*(1.-rainStrength);
 }
 vec3 m(vec3 v,vec3 f,vec3 y,vec3 x,int z)
 {
   if(rainStrength>.99)
     return vec3(0.);
   v+=1.;
   v-=Fract01(cameraPosition+.5);
   vec3 i=m(v);
   float n=.5;
   vec3 r=vec3(1.)*shadow2DLod(shadowtex0,vec3(i.xy,i.z-.0006*n),2).x;
   r*=saturate(dot(f,y));
   r=TintUnderwaterDepth(r);
   #ifdef GI_SUNLIGHT_STAINED_GLASS_TINT
   float s=shadow2DLod(shadowtex0,vec3(i.xy-vec2(.5,0.),i.z-.0006*n),3).x;
   vec3 c=texture2DLod(shadowcolor,vec2(i.xy-vec2(.5,0.)),3).xyz;
   c*=c;
   r=mix(r,r*c,vec3(1.-s));
   #endif
   return r*(1.-rainStrength);
 }struct veHQsJlbTL{float nnNEIJGkdr;float KFTSJGnGnw;float ofqplrivFA;float WMbBZukiRr;vec3 JWRqQQkOhM;};
 vec4 i(veHQsJlbTL v)
 {
   vec4 f;
   v.JWRqQQkOhM=max(vec3(0.),v.JWRqQQkOhM);
   f.x=v.nnNEIJGkdr;
   v.JWRqQQkOhM=pow(v.JWRqQQkOhM,vec3(.125));
   f.y=PackTwo16BitTo32Bit(v.JWRqQQkOhM.x,v.ofqplrivFA);
   f.z=PackTwo16BitTo32Bit(v.JWRqQQkOhM.y,v.WMbBZukiRr);
   f.w=PackTwo16BitTo32Bit(v.JWRqQQkOhM.z,v.KFTSJGnGnw);
   return f;
 }
 veHQsJlbTL h(vec4 v)
 {
   veHQsJlbTL f;
   vec2 m=UnpackTwo16BitFrom32Bit(v.y),i=UnpackTwo16BitFrom32Bit(v.z),n=UnpackTwo16BitFrom32Bit(v.w);
   f.nnNEIJGkdr=v.x;
   f.ofqplrivFA=m.y;
   f.WMbBZukiRr=i.y;
   f.KFTSJGnGnw=n.y;
   f.JWRqQQkOhM=pow(vec3(m.x,i.x,n.x),vec3(8.));
   return f;
 }
 veHQsJlbTL R(vec2 v)
 {
   vec2 x=1./vec2(viewWidth,viewHeight),y=vec2(viewWidth,viewHeight);
   v=(floor(v*y)+.5)*x;
   return h(texture2DLod(colortex5,v,0));
 }
 float R(float v,float y)
 {
   float x=1.;
   #ifdef FULL_RT_REFLECTIONS
   x=clamp(pow(v,.125)+y,0.,1.);
   #else
   x=clamp(v*10.-7.,0.,1.);
   #endif
   return x;
 }
 bool R(vec3 v,float y,Ray f,bool x,inout float i,inout vec3 z)
 {
   bool r=false,m=false;
   #if RAYTRACE_GEOMETRY_QUALITY==0
   if(x)
     return false;
   if(y>=67.)
     return false;
   m=d(v,v+vec3(1.,1.,1.),f,i,z);
   r=m;
   #else
   if(y<40.)
     return m=d(v,v+vec3(1.,1.,1.),f,i,z),m;
   if(y==40.||y==41.||y>=43.&&y<=54.)
     {
       float s=.5;
       if(y==41.)
         s=.9375;
       m=d(v+vec3(0.,0.,0.),v+vec3(1.,s,1.),f,i,z);
       r=r||m;
     }
   if(y==42.||y>=55.&&y<=66.)
     m=d(v+vec3(0.,.5,0.),v+vec3(1.,1.,1.),f,i,z),r=r||m;
   if(y==43.||y==46.||y==47.||y==52.||y==53.||y==54.||y==55.||y==58.||y==59.||y==64.||y==65.||y==66.)
     {
       float s=.5;
       if(y==55.||y==58.||y==59.||y==64.||y==65.||y==66.)
         s=0.;
       m=d(v+vec3(0.,s,0.),v+vec3(.5,.5+s,.5),f,i,z);
       r=r||m;
     }
   if(y==43.||y==45.||y==48.||y==51.||y==53.||y==54.||y==55.||y==57.||y==60.||y==63.||y==65.||y==66.)
     {
       float s=.5;
       if(y==55.||y==57.||y==60.||y==63.||y==65.||y==66.)
         s=0.;
       m=d(v+vec3(.5,s,0.),v+vec3(1.,.5+s,.5),f,i,z);
       r=r||m;
     }
   if(y==44.||y==45.||y==49.||y==51.||y==52.||y==54.||y==56.||y==57.||y==61.||y==63.||y==64.||y==66.)
     {
       float s=.5;
       if(y==56.||y==57.||y==61.||y==63.||y==64.||y==66.)
         s=0.;
       m=d(v+vec3(.5,s,.5),v+vec3(1.,.5+s,1.),f,i,z);
       r=r||m;
     }
   if(y==44.||y==46.||y==50.||y==51.||y==52.||y==53.||y==56.||y==58.||y==62.||y==63.||y==64.||y==65.)
     {
       float s=.5;
       if(y==56.||y==58.||y==62.||y==63.||y==64.||y==65.)
         s=0.;
       m=d(v+vec3(0.,s,.5),v+vec3(.5,.5+s,1.),f,i,z);
       r=r||m;
     }
   if(y>=67.&&y<=82.)
     m=d(v+vec3(6.,0.,6.)/16.,v+vec3(10.,16.,10.)/16.,f,i,z),r=r||m;
   if(y==68.||y==69.||y==70.||y==72.||y==73.||y==74.||y==76.||y==77.||y==78.||y==80.||y==81.||y==82.)
     {
       float s=8.,c=8.;
       if(y==68.||y==70.||y==72.||y==74.||y==76.||y==78.||y==80.||y==82.)
         s=0.;
       if(y==69.||y==70.||y==73.||y==74.||y==77.||y==78.||y==81.||y==82.)
         c=16.;
       m=d(v+vec3(s,6.,7.)/16.,v+vec3(c,9.,9.)/16.,f,i,z);
       r=r||m;
       m=d(v+vec3(s,12.,7.)/16.,v+vec3(c,15.,9.)/16.,f,i,z);
       r=r||m;
     }
   if(y>=71.&&y<=82.)
     {
       float s=8.,n=8.;
       if(y>=71.&&y<=74.||y>=79.&&y<=82.)
         n=16.;
       if(y>=75.&&y<=82.)
         s=0.;
       m=d(v+vec3(7.,6.,s)/16.,v+vec3(9.,9.,n)/16.,f,i,z);
       r=r||m;
       m=d(v+vec3(7.,12.,s)/16.,v+vec3(9.,15.,n)/16.,f,i,z);
       r=r||m;
     }
   #if RAYTRACE_GEOMETRY_QUALITY==2
   if(y>=83.&&y<=86.)
     {
       vec3 s=vec3(0),c=vec3(0);
       if(y==83.)
         s=vec3(0,0,0),c=vec3(16,16,3);
       if(y==84.)
         s=vec3(0,0,13),c=vec3(16,16,16);
       if(y==86.)
         s=vec3(0,0,0),c=vec3(3,16,16);
       if(y==85.)
         s=vec3(13,0,0),c=vec3(16,16,16);
       m=d(v+s/16.,v+c/16.,f,i,z);
       r=r||m;
     }
   if(y>=87.&&y<=102.)
     {
       vec3 s=vec3(0.),c=vec3(1.);
       if(y>=87.&&y<=94.)
         {
           float n=0.;
           if(y>=91.&&y<=94.)
             n=13.;
           s=vec3(0.,n,0.)/16.;
           c=vec3(16.,n+3.,16.)/16.;
         }
       if(y>=95.&&y<=98.)
         {
           float n=13.;
           if(y==97.||y==98.)
             n=0.;
           s=vec3(0.,0.,n)/16.;
           c=vec3(16.,16.,n+3.)/16.;
         }
       if(y>=99.&&y<=102.)
         {
           float n=13.;
           if(y==99.||y==100.)
             n=0.;
           s=vec3(n,0.,0.)/16.;
           c=vec3(n+3.,16.,16.)/16.;
         }
       m=d(v+s,v+c,f,i,z);
       r=r||m;
     }
   if(y>=103.&&y<=113.)
     {
       vec3 s=vec3(0.),n=vec3(1.);
       if(y>=103.&&y<=110.)
         {
           float c=float(y)-float(103.)+1.;
           n.y=c*2./16.;
         }
       if(y==111.)
         n.y=.0625;
       if(y==112.)
         s=vec3(1.,0.,1.)/16.,n=vec3(15.,1.,15.)/16.;
       if(y==113.)
         s=vec3(1.,0.,1.)/16.,n=vec3(15.,.5,15.)/16.;
       m=d(v+s,v+n,f,i,z);
       r=r||m;
     }
   #endif
   #endif
   return r;
 }
 float e(float v,float y)
 {
   return exp(-pow(v/(.9*y),2.));
 }
 float h(vec3 v,vec3 y)
 {
   return dot(abs(v-y),vec3(.3333));
 }
 vec3 z(vec2 v)
 {
   vec2 y=vec2(v.xy*vec2(viewWidth,viewHeight))/64.;
   const vec2 f[16]=vec2[16](vec2(-1,-1),vec2(0,-.333333),vec2(-.5,.333333),vec2(.5,-.777778),vec2(-.75,-.111111),vec2(.25,.555556),vec2(-.25,-.555556),vec2(.75,.111111),vec2(-.875,.777778),vec2(.125,-.925926),vec2(-.375,-.259259),vec2(.625,.407407),vec2(-.625,-.703704),vec2(.375,-.037037),vec2(-.125,.62963),vec2(.875,-.481482));
   if(v.x<2./viewWidth||v.x>1.-2./viewWidth||v.y<2./viewHeight||v.y>1.-2./viewHeight)
     ;
   y=(floor(y*64.)+.5)/64.;
   vec3 i=texture2D(noisetex,y).xyz,s=vec3(sqrt(.2),sqrt(2.),1.61803);
   i=mod(i+vec3(s)*mod(frameCounter,64.f),vec3(1.));
   return i;
 }
 vec3 R(float v,float f,float y,vec3 i)
 {
   vec3 m;
   m.x=y*cos(v);
   m.y=y*sin(v);
   m.z=f;
   vec3 s=abs(i.y)<.999?vec3(0,0,1):vec3(1,0,0),x=normalize(cross(i,vec3(0.,1.,1.))),c=cross(x,i);
   return x*m.x+c*m.y+i*m.z;
 }
 vec3 R(vec2 v,float y,vec3 z)
 {
   float f=2*3.14159*v.x,x=sqrt((1-v.y)/(1+(y*y-1)*v.y)),s=sqrt(1-x*x);
   return R(f,x,s,z);
 }
 float G(float v)
 {
   return 2./(v*v+1e-07)-2.;
 }
 vec3 G(in vec2 v,in float y,in vec3 z)
 {
   float f=G(y),i=2*3.14159*v.x,x=pow(v.y,1.f/(f+1.f)),s=sqrt(1-x*x);
   return R(i,x,s,z);
 }
 float a(vec2 v)
 {
   return texture2DLod(colortex3,v,0).w;
 }
 float G(float v,float y)
 {
   return v/(y*20.01+1.);
 }
 vec2 a(vec2 v,float y)
 {
   vec2 s=v;
   mat2 x=mat2(cos(y),-sin(y),sin(y),cos(y));
   v=x*v;
   return v;
 }
 vec4 G(sampler2D v,float f,bool y,float i,float s,float z,float x)
 {
   GBufferData m=GetGBufferData();
   GBufferDataTransparent n=GetGBufferDataTransparent();
   bool r=n.depth<m.depth;
   if(r)
     m.normal=n.normal,m.smoothness=n.smoothness,m.metalness=0.,m.mcLightmap=n.mcLightmap,m.depth=n.depth;
   vec4 c=GetViewPosition(texcoord.xy,m.depth),w=gbufferModelViewInverse*vec4(c.xyz,1.),d=gbufferModelViewInverse*vec4(c.xyz,0.);
   vec3 t=normalize(c.xyz),o=normalize(d.xyz),A=normalize((gbufferModelViewInverse*vec4(m.normal,0.)).xyz);
   float p=GetDepthLinear(texcoord.xy),l=dot(-t,m.normal.xyz),e=1.-m.smoothness,M=e*e,b=R(m.smoothness,m.metalness);
   vec4 W=texture2DLod(colortex6,texcoord.xy,0);
   float Y=Luminance(W.xyz);
   if(b<.001)
     return W;
   float g=f*.9;
   g*=min(M*20.,1.1);
   g*=mix(W.w,1.,1.);
   vec2 D=vec2(0.);
   if(y)
     {
       vec2 T=BlueNoiseTemporal(texcoord.xy).xy*.99+.005;
       D=T-.5;
     }
   float T=0.,S=1.1,u=G(i,m.totalTexGrad)/(M+.0001),L=G(s,m.totalTexGrad);
   vec4 P=vec4(0.),Q=vec4(0.);
   float U=0.;
   vec4 H=vec4(vec3(z),1.);
   H.xyz=vec3(.5);
   H.xyz*=W.w*.95+.05;
   float J=m.smoothness;
   vec2 F=normalize(cross(m.normal,t).xy),k=a(F,1.5708);
   float K=1.-pow(1.-saturate(l),1.);
   F*=mix(.1675,.5,K);
   k*=mix(mix(.7,.7,M),.5,K);
   vec3 N=reflect(-t,m.normal);
   int B=0;
   for(int I=-1;I<=1;I++)
     {
       for(int V=-1;V<=1;V++)
         {
           vec2 q=vec2(I,V)+D;
           q=q.x*F+q.y*k;
           q*=g*1.5/vec2(viewWidth,viewHeight);
           vec2 E=texcoord.xy+q.xy;
           float X=length(q*vec2(viewWidth,viewHeight));
           if(X*.025>W.w+.1)
             {
               continue;
             }
           E=clamp(E,4./vec2(viewWidth,viewHeight),1.-4./vec2(viewWidth,viewHeight));
           vec4 O=texture2DLod(colortex6,E,0);
           vec3 C=GetNormals(E);
           float j=GetDepthLinear(E),Z=pow(saturate(dot(N,reflect(-t,C))),105./M),ab=exp(-(abs(j-p)*S)),ac=exp(-(h(O.xyz,W.xyz)*T)),ad=exp(-abs(J-a(E))*L),ae=Z*ab*ac*ad;
           P+=vec4(pow(length(O.xyz),H.x)*normalize(O.xyz+1e-05),O.w)*ae;
           U+=ae;
           Q+=O;
           B++;
         }
     }
   P/=U+.0001;
   P.xyz=pow(length(P.xyz),1./H.x)*normalize(P.xyz+1e-06);
   vec4 q=P;
   if(U<.001)
     q=W;
   return q;
 }
 void main()
 {
   vec4 v=texture2DLod(colortex6,texcoord.xy,4);
   vec3 y=pow(texture2DLod(colortex3,texcoord.xy,2).xyz,vec3(2.2)),s=GetViewPosition(texcoord.xy,GetDepth(texcoord.xy)).xyz,z=GetNormals(texcoord.xy);
   float m=pow(1.-saturate(dot(-normalize(s),z)),5.);
   v.xyz*=m;
   float x=dot(max(vec3(0.),vec3(v.xyz-y.xyz*20.)),vec3(240.));
   vec4 f=texture2DLod(colortex6,texcoord.xy,0);
   f=G(colortex6,15.,false,180.,40.,.1,0.);
   gl_FragData[0]=vec4(f);
 };




/* DRAWBUFFERS:6 */
