#version 330 compatibility



/*
 _______ _________ _______  _______  _ 
(  ____ \\__   __/(  ___  )(  ____ )( )
| (    \/   ) (   | (   ) || (    )|| |
| (_____    | |   | |   | || (____)|| |
(_____  )   | |   | |   | ||  _____)| |
      ) |   | |   | |   | || (      (_)
/\____) |   | |   | (___) || )       _ 
\_______)   )_(   (_______)|/       (_)

Do not modify this code until you have read the LICENSE.txt contained in the root directory of this shaderpack!

*/

/////////ADJUSTABLE VARIABLES//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////ADJUSTABLE VARIABLES//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



//#define HALF_RES_TRACE

/////////INTERNAL VARIABLES////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////INTERNAL VARIABLES////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Do not change the name of these variables or their type. The Shaders Mod reads these lines and determines values to send to the inner-workings
//of the shaders mod. The shaders mod only reads these lines and doesn't actually know the real value assigned to these variables in GLSL.
//Some of these variables are critical for proper operation. Change at your own risk.

const bool colortex4Clear = false;
const bool colortex5Clear = false;
//END OF INTERNAL VARIABLES//




in vec4 texcoord;

in float timeMidnight;

in vec3 colorSunlight;
in vec3 colorSkylight;
in vec3 colorSkyUp;
in vec3 colorTorchlight;

in vec4 skySHR;
in vec4 skySHG;
in vec4 skySHB;


in vec3 worldLightVector;
in vec3 worldSunVector;


in mat4 gbufferPreviousModelViewInverse;
in mat4 gbufferPreviousProjectionInverse;


#include "lib/Uniforms.inc"
#include "lib/Common.inc"

#include "lib/Materials.inc"


/////////////////////////FUNCTIONS/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////FUNCTIONS/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////






// vec4 GetViewPosition(in vec2 coord, in float depth) 
// {	
// 	vec2 tcoord = coord;
// 	TemporalJitterProjPosInv01(tcoord);

// 	vec4 fragposition = gbufferProjectionInverse * vec4(tcoord.s * 2.0f - 1.0f, tcoord.t * 2.0f - 1.0f, 2.0f * depth - 1.0f, 1.0f);
// 		 fragposition /= fragposition.w;

	
// 	return fragposition;
// }




vec2 GetNearFragment(vec2 coord, float depth, out float minDepth)
{
	
	
	vec2 texel = 1.0 / vec2(viewWidth, viewHeight);
	vec4 depthSamples;
	depthSamples.x = texture2D(depthtex1, coord + texel * vec2(1.0, 1.0)).x;
	depthSamples.y = texture2D(depthtex1, coord + texel * vec2(1.0, -1.0)).x;
	depthSamples.z = texture2D(depthtex1, coord + texel * vec2(-1.0, 1.0)).x;
	depthSamples.w = texture2D(depthtex1, coord + texel * vec2(-1.0, -1.0)).x;

	vec2 targetFragment = vec2(0.0, 0.0);

	if (depthSamples.x < depth)
		targetFragment = vec2(1.0, 1.0);
	if (depthSamples.y < depth)
		targetFragment = vec2(1.0, -1.0);
	if (depthSamples.z < depth)
		targetFragment = vec2(-1.0, 1.0);
	if (depthSamples.w < depth)
		targetFragment = vec2(-1.0, -1.0);


	minDepth = min(min(min(depthSamples.x, depthSamples.y), depthSamples.z), depthSamples.w);

	return coord + texel * targetFragment;
}










#include "lib/GBufferData.inc"





 int f(float v)
 {
   return int(floor(v));
 }
 int t(int v)
 {
   return v-f(mod(float(v),2.))-0;
 }
 int d(int v)
 {
   return v-f(mod(float(v),2.))-1;
 }
 int d()
 {
   ivec2 v=ivec2(viewWidth,viewHeight);
   int y=v.x*v.y;
   return t(f(floor(pow(float(y),.333333))));
 }
 int f()
 {
   ivec2 v=ivec2(2048,2048);
   int y=v.x*v.y;
   return d(f(floor(pow(float(y),.333333))));
 }
 vec3 v(vec2 v)
 {
   ivec2 f=ivec2(viewWidth,viewHeight);
   int x=f.x*f.y,y=d();
   ivec2 n=ivec2(v.x*f.x,v.y*f.y);
   float z=float(n.y/y),i=float(int(n.x+mod(f.x*z,y))/y);
   i+=floor(f.x*z/y);
   vec3 m=vec3(0.,0.,i);
   m.x=mod(n.x+mod(f.x*z,y),y);
   m.y=mod(n.y,y);
   m.xyz=floor(m.xyz);
   m/=y;
   m.xyz=m.xzy;
   return m;
 }
 vec2 s(vec3 v)
 {
   ivec2 f=ivec2(viewWidth,viewHeight);
   int z=d();
   vec3 i=v.xzy*z;
   i=floor(i+1e-05);
   float x=i.z;
   vec2 n;
   n.x=mod(i.x+x*z,f.x);
   float s=i.x+x*z;
   n.y=i.y+floor(s/f.x)*z;
   n+=.5;
   n/=f;
   return n;
 }
 vec3 x(vec2 v)
 {
   vec2 i=v;
   i.xy/=.5;
   ivec2 m=ivec2(2048,2048);
   int x=m.x*m.y,y=f();
   ivec2 n=ivec2(i.x*m.x,i.y*m.y);
   float z=float(n.y/y),r=float(int(n.x+mod(m.x*z,y))/y);
   r+=floor(m.x*z/y);
   vec3 s=vec3(0.,0.,r);
   s.x=mod(n.x+mod(m.x*z,y),y);
   s.y=mod(n.y,y);
   s.xyz=floor(s.xyz);
   s/=y;
   s.xyz=s.xzy;
   return s;
 }
 vec2 d(vec3 v,int y)
 {
   v=clamp(v,vec3(0.),vec3(1.));
   ivec2 f=ivec2(2048,2048);
   vec3 i=v.xzy*y;
   i=floor(i+1e-05);
   float x=i.z;
   vec2 n;
   n.x=mod(i.x+x*y,f.x);
   float s=i.x+x*y;
   n.y=i.y+floor(s/f.x)*y;
   n+=.5;
   n/=f;
   n.xy*=.5;
   return n;
 }
 vec3 f(vec3 v,int y)
 {
   return v*=1./y,v=v+vec3(.5),v=clamp(v,vec3(0.),vec3(1.)),v;
 }
 vec3 s(vec3 v,int y)
 {
   return v*=1./y,v=v+vec3(.5),v;
 }
 vec3 m(vec3 v)
 {
   int m=f();
   v=v-vec3(.5);
   v*=m;
   return v;
 }
 vec3 e(vec3 v)
 {
   int y=d();
   v*=1./y;
   v=v+vec3(.5);
   v=clamp(v,vec3(0.),vec3(1.));
   return v;
 }
 vec3 n(vec3 v)
 {
   int m=d();
   v=v-vec3(.5);
   v*=m;
   return v;
 }
 vec3 e()
 {
   vec3 v=cameraPosition.xyz+.5,i=previousCameraPosition.xyz+.5,y=floor(v-.0001),x=floor(i-.0001);
   return y-x;
 }
 vec3 r(vec3 v)
 {
   vec4 f=vec4(v,1.);
   f=shadowModelView*f;
   f=shadowProjection*f;
   f/=f.w;
   float x=sqrt(f.x*f.x+f.y*f.y),y=1.f-SHADOW_MAP_BIAS+x*SHADOW_MAP_BIAS;
   f.xy*=.95f/y;
   f.z=mix(f.z,.5,.8);
   f=f*.5f+.5f;
   f.xy*=.5;
   f.xy+=.5;
   return f.xyz;
 }
 vec3 d(vec3 v,vec3 f,vec2 n,vec2 z,vec4 i,vec4 y,inout float x,out vec2 r)
 {
   bool m=fract(v.x*2.)>.01&&fract(v.x*2.)<.99||fract(v.y*2.)>.01&&fract(v.y*2.)<.99||fract(v.z*2.)>.01&&fract(v.z*2.)<.99;
   m=!m;
   if(y.x==8||y.x==9||y.x==79||y.x<1.||!m||y.x==20.||y.x==171.||min(abs(f.x),abs(f.z))>.2)
     x=1.;
   if(y.x==50.||y.x==76.)
     {
       x=0.;
       if(f.y<.5)
         x=1.;
     }
   if(y.x==51)
     x=0.;
   vec3 s,c;
   if(f.x>.5)
     s=vec3(0.,0.,-1.),c=vec3(0.,-1.,0.);
   else
      if(f.x<-.5)
       s=vec3(0.,0.,1.),c=vec3(0.,-1.,0.);
     else
        if(f.y>.5)
         s=vec3(1.,0.,0.),c=vec3(0.,0.,1.);
       else
          if(f.y<-.5)
           s=vec3(1.,0.,0.),c=vec3(0.,0.,-1.);
         else
            if(f.z>.5)
             s=vec3(1.,0.,0.),c=vec3(0.,-1.,0.);
           else
              if(f.z<-.5)
               s=vec3(-1.,0.,0.),c=vec3(0.,-1.,0.);
   r=clamp((n.xy-z.xy)*100000.,vec2(0.),vec2(1.));
   float t=.15,w=.15;
   if(y.x==10.||y.x==11.)
     {
       if(abs(f.y)<.01&&m||f.y>.99)
         t=.1,w=.1,x=0.;
       else
          x=1.;
     }
   if(y.x==51)
     t=.5,w=.1;
   if(y.x==76)
     t=.2,w=.2;
   if(y.x-255.+39.>=103.&&y.x-255.+39.<=113.)
     w=.025,t=.025;
   s=normalize(i.xyz);
   c=normalize(cross(s,f.xyz)*sign(i.w));
   vec3 e=v.xyz+mix(s*t,-s*t,vec3(r.x));
   e.xyz+=mix(c*t,-c*t,vec3(r.y));
   e.xyz-=f.xyz*w;
   return e;
 }struct zdAtCTBXEz{vec3 ipiiYVkNiW;vec3 ipiiYVkNiWOrigin;vec3 yTinzyAggr;vec3 DagoLvaZQG;vec3 wPmXjhNUmn;vec3 HXMzbpgVIA;};
 zdAtCTBXEz p(Ray v)
 {
   zdAtCTBXEz f;
   f.ipiiYVkNiW=floor(v.origin);
   f.ipiiYVkNiWOrigin=f.ipiiYVkNiW;
   f.yTinzyAggr=abs(vec3(length(v.direction))/(v.direction+1e-07));
   f.DagoLvaZQG=sign(v.direction);
   f.wPmXjhNUmn=(sign(v.direction)*(f.ipiiYVkNiW-v.origin)+sign(v.direction)*.5+.5)*f.yTinzyAggr;
   f.HXMzbpgVIA=vec3(0.);
   return f;
 }
 void i(inout zdAtCTBXEz v)
 {
   v.HXMzbpgVIA=step(v.wPmXjhNUmn.xyz,v.wPmXjhNUmn.yzx)*step(v.wPmXjhNUmn.xyz,v.wPmXjhNUmn.zxy),v.wPmXjhNUmn+=v.HXMzbpgVIA*v.yTinzyAggr,v.ipiiYVkNiW+=v.HXMzbpgVIA*v.DagoLvaZQG;
 }
 void d(in Ray v,in vec3 f[2],out float i,out float y)
 {
   float x,z,r,w;
   i=(f[v.sign[0]].x-v.origin.x)*v.inv_direction.x;
   y=(f[1-v.sign[0]].x-v.origin.x)*v.inv_direction.x;
   x=(f[v.sign[1]].y-v.origin.y)*v.inv_direction.y;
   z=(f[1-v.sign[1]].y-v.origin.y)*v.inv_direction.y;
   r=(f[v.sign[2]].z-v.origin.z)*v.inv_direction.z;
   w=(f[1-v.sign[2]].z-v.origin.z)*v.inv_direction.z;
   i=max(max(i,x),r);
   y=min(min(y,z),w);
 }
 vec3 d(const vec3 v,const vec3 f,vec3 y)
 {
   const float x=1e-05;
   vec3 z=(f+v)*.5,n=(f-v)*.5,i=y-z,r=vec3(0.);
   r+=vec3(sign(i.x),0.,0.)*step(abs(abs(i.x)-n.x),x);
   r+=vec3(0.,sign(i.y),0.)*step(abs(abs(i.y)-n.y),x);
   r+=vec3(0.,0.,sign(i.z))*step(abs(abs(i.z)-n.z),x);
   return normalize(r);
 }
 bool e(const vec3 v,const vec3 f,Ray m,out vec2 i)
 {
   vec3 y=m.inv_direction*(v-m.origin),x=m.inv_direction*(f-m.origin),n=min(x,y),c=max(x,y);
   vec2 r=max(n.xx,n.yz);
   float z=max(r.x,r.y);
   r=min(c.xx,c.yz);
   float s=min(r.x,r.y);
   i.x=z;
   i.y=s;
   return s>max(z,0.);
 }
 bool d(const vec3 v,const vec3 f,Ray m,inout float y,inout vec3 x)
 {
   vec3 z=m.inv_direction*(v-1e-05-m.origin),i=m.inv_direction*(f+1e-05-m.origin),n=min(i,z),c=max(i,z);
   vec2 r=max(n.xx,n.yz);
   float s=max(r.x,r.y);
   r=min(c.xx,c.yz);
   float t=min(r.x,r.y);
   bool w=t>max(s,0.)&&max(s,0.)<y;
   if(w)
     x=d(v-1e-05,f+1e-05,m.origin+m.direction*s),y=s;
   return w;
 }
 vec3 e(vec3 v,vec3 f,vec3 y,vec3 z,int x)
 {
   if(rainStrength>.99)
     return vec3(0.);
   v+=1.;
   v-=Fract01(cameraPosition+.5);
   vec3 i=r(v);
   float s=.5;
   vec3 n=vec3(1.)*shadow2DLod(shadowtex0,vec3(i.xy,i.z-.0006*s),2).x;
   n*=saturate(dot(f,y));
   {
     vec4 m=texture2DLod(shadowcolor1,i.xy-vec2(0.,.5),4);
     float w=abs(m.x*256.-(v.y+cameraPosition.y)),c=GetCausticsComposite(v,f,w),t=shadow2DLod(shadowtex0,vec3(i.xy-vec2(0.,.5),i.z+1e-06),4).x;
     n=mix(n,n*c,1.-t);
   }
   n=TintUnderwaterDepth(n);
   return n*(1.-rainStrength);
 }
 vec3 f(vec3 v,vec3 f,vec3 y,vec3 z,int x)
 {
   if(rainStrength>.99)
     return vec3(0.);
   vec3 i=m(v),n=r(i+y*.99);
   float s=.5;
   vec3 t=vec3(1.)*shadow2DLod(shadowtex0,vec3(n.xy,n.z-.0006*s),3).x;
   t*=saturate(dot(f,y));
   t=TintUnderwaterDepth(t);
   #ifdef GI_SUNLIGHT_STAINED_GLASS_TINT
   float w=shadow2DLod(shadowtex0,vec3(n.xy-vec2(.5,0.),n.z-.0006*s),3).x;
   vec3 c=texture2DLod(shadowcolor,vec2(n.xy-vec2(.5,0.)),3).xyz;
   c*=c;
   t=mix(t,t*c,vec3(1.-w));
   #endif
   return t*(1.-rainStrength);
 }
 vec3 i(vec3 v,vec3 f,vec3 y,vec3 z,int x)
 {
   if(rainStrength>.99)
     return vec3(0.);
   v+=1.;
   v-=Fract01(cameraPosition+.5);
   vec3 i=r(v);
   float s=.5;
   vec3 n=vec3(1.)*shadow2DLod(shadowtex0,vec3(i.xy,i.z-.0006*s),2).x;
   n*=saturate(dot(f,y));
   n=TintUnderwaterDepth(n);
   #ifdef GI_SUNLIGHT_STAINED_GLASS_TINT
   float t=shadow2DLod(shadowtex0,vec3(i.xy-vec2(.5,0.),i.z-.0006*s),3).x;
   vec3 m=texture2DLod(shadowcolor,vec2(i.xy-vec2(.5,0.)),3).xyz;
   m*=m;
   n=mix(n,n*m,vec3(1.-t));
   #endif
   return n*(1.-rainStrength);
 }struct veHQsJlbTL{float nnNEIJGkdr;float KFTSJGnGnw;float ofqplrivFA;float WMbBZukiRr;vec3 JWRqQQkOhM;};
 vec4 h(veHQsJlbTL v)
 {
   vec4 f;
   v.JWRqQQkOhM=max(vec3(0.),v.JWRqQQkOhM);
   f.x=v.nnNEIJGkdr;
   v.JWRqQQkOhM=pow(v.JWRqQQkOhM,vec3(.125));
   f.y=PackTwo16BitTo32Bit(v.JWRqQQkOhM.x,v.ofqplrivFA);
   f.z=PackTwo16BitTo32Bit(v.JWRqQQkOhM.y,v.WMbBZukiRr);
   f.w=PackTwo16BitTo32Bit(v.JWRqQQkOhM.z,v.KFTSJGnGnw);
   return f;
 }
 veHQsJlbTL w(vec4 v)
 {
   veHQsJlbTL f;
   vec2 i=UnpackTwo16BitFrom32Bit(v.y),m=UnpackTwo16BitFrom32Bit(v.z),n=UnpackTwo16BitFrom32Bit(v.w);
   f.nnNEIJGkdr=v.x;
   f.ofqplrivFA=i.y;
   f.WMbBZukiRr=m.y;
   f.KFTSJGnGnw=n.y;
   f.JWRqQQkOhM=pow(vec3(i.x,m.x,n.x),vec3(8.));
   return f;
 }
 veHQsJlbTL g(vec2 v)
 {
   vec2 f=1./vec2(viewWidth,viewHeight),y=vec2(viewWidth,viewHeight);
   v=(floor(v*y)+.5)*f;
   return w(texture2DLod(colortex5,v,0));
 }
 float e(float v,float y)
 {
   float f=1.;
   #ifdef FULL_RT_REFLECTIONS
   f=clamp(pow(v,.125)+y,0.,1.);
   #else
   f=clamp(v*10.-7.,0.,1.);
   #endif
   return f;
 }
 bool d(vec3 v,float y,Ray f,bool z,inout float x,inout vec3 i)
 {
   bool m=false,r=false;
   #if RAYTRACE_GEOMETRY_QUALITY==0
   if(z)
     return false;
   if(y>=67.)
     return false;
   r=d(v,v+vec3(1.,1.,1.),f,x,i);
   m=r;
   #else
   if(y<40.)
     return r=d(v,v+vec3(1.,1.,1.),f,x,i),r;
   if(y==40.||y==41.||y>=43.&&y<=54.)
     {
       float n=.5;
       if(y==41.)
         n=.9375;
       r=d(v+vec3(0.,0.,0.),v+vec3(1.,n,1.),f,x,i);
       m=m||r;
     }
   if(y==42.||y>=55.&&y<=66.)
     r=d(v+vec3(0.,.5,0.),v+vec3(1.,1.,1.),f,x,i),m=m||r;
   if(y==43.||y==46.||y==47.||y==52.||y==53.||y==54.||y==55.||y==58.||y==59.||y==64.||y==65.||y==66.)
     {
       float n=.5;
       if(y==55.||y==58.||y==59.||y==64.||y==65.||y==66.)
         n=0.;
       r=d(v+vec3(0.,n,0.),v+vec3(.5,.5+n,.5),f,x,i);
       m=m||r;
     }
   if(y==43.||y==45.||y==48.||y==51.||y==53.||y==54.||y==55.||y==57.||y==60.||y==63.||y==65.||y==66.)
     {
       float n=.5;
       if(y==55.||y==57.||y==60.||y==63.||y==65.||y==66.)
         n=0.;
       r=d(v+vec3(.5,n,0.),v+vec3(1.,.5+n,.5),f,x,i);
       m=m||r;
     }
   if(y==44.||y==45.||y==49.||y==51.||y==52.||y==54.||y==56.||y==57.||y==61.||y==63.||y==64.||y==66.)
     {
       float n=.5;
       if(y==56.||y==57.||y==61.||y==63.||y==64.||y==66.)
         n=0.;
       r=d(v+vec3(.5,n,.5),v+vec3(1.,.5+n,1.),f,x,i);
       m=m||r;
     }
   if(y==44.||y==46.||y==50.||y==51.||y==52.||y==53.||y==56.||y==58.||y==62.||y==63.||y==64.||y==65.)
     {
       float n=.5;
       if(y==56.||y==58.||y==62.||y==63.||y==64.||y==65.)
         n=0.;
       r=d(v+vec3(0.,n,.5),v+vec3(.5,.5+n,1.),f,x,i);
       m=m||r;
     }
   if(y>=67.&&y<=82.)
     r=d(v+vec3(6.,0.,6.)/16.,v+vec3(10.,16.,10.)/16.,f,x,i),m=m||r;
   if(y==68.||y==69.||y==70.||y==72.||y==73.||y==74.||y==76.||y==77.||y==78.||y==80.||y==81.||y==82.)
     {
       float n=8.,c=8.;
       if(y==68.||y==70.||y==72.||y==74.||y==76.||y==78.||y==80.||y==82.)
         n=0.;
       if(y==69.||y==70.||y==73.||y==74.||y==77.||y==78.||y==81.||y==82.)
         c=16.;
       r=d(v+vec3(n,6.,7.)/16.,v+vec3(c,9.,9.)/16.,f,x,i);
       m=m||r;
       r=d(v+vec3(n,12.,7.)/16.,v+vec3(c,15.,9.)/16.,f,x,i);
       m=m||r;
     }
   if(y>=71.&&y<=82.)
     {
       float n=8.,t=8.;
       if(y>=71.&&y<=74.||y>=79.&&y<=82.)
         t=16.;
       if(y>=75.&&y<=82.)
         n=0.;
       r=d(v+vec3(7.,6.,n)/16.,v+vec3(9.,9.,t)/16.,f,x,i);
       m=m||r;
       r=d(v+vec3(7.,12.,n)/16.,v+vec3(9.,15.,t)/16.,f,x,i);
       m=m||r;
     }
   #if RAYTRACE_GEOMETRY_QUALITY==2
   if(y>=83.&&y<=86.)
     {
       vec3 n=vec3(0),c=vec3(0);
       if(y==83.)
         n=vec3(0,0,0),c=vec3(16,16,3);
       if(y==84.)
         n=vec3(0,0,13),c=vec3(16,16,16);
       if(y==86.)
         n=vec3(0,0,0),c=vec3(3,16,16);
       if(y==85.)
         n=vec3(13,0,0),c=vec3(16,16,16);
       r=d(v+n/16.,v+c/16.,f,x,i);
       m=m||r;
     }
   if(y>=87.&&y<=102.)
     {
       vec3 n=vec3(0.),c=vec3(1.);
       if(y>=87.&&y<=94.)
         {
           float t=0.;
           if(y>=91.&&y<=94.)
             t=13.;
           n=vec3(0.,t,0.)/16.;
           c=vec3(16.,t+3.,16.)/16.;
         }
       if(y>=95.&&y<=98.)
         {
           float t=13.;
           if(y==97.||y==98.)
             t=0.;
           n=vec3(0.,0.,t)/16.;
           c=vec3(16.,16.,t+3.)/16.;
         }
       if(y>=99.&&y<=102.)
         {
           float s=13.;
           if(y==99.||y==100.)
             s=0.;
           n=vec3(s,0.,0.)/16.;
           c=vec3(s+3.,16.,16.)/16.;
         }
       r=d(v+n,v+c,f,x,i);
       m=m||r;
     }
   if(y>=103.&&y<=113.)
     {
       vec3 n=vec3(0.),c=vec3(1.);
       if(y>=103.&&y<=110.)
         {
           float s=float(y)-float(103.)+1.;
           c.y=s*2./16.;
         }
       if(y==111.)
         c.y=.0625;
       if(y==112.)
         n=vec3(1.,0.,1.)/16.,c=vec3(15.,1.,15.)/16.;
       if(y==113.)
         n=vec3(1.,0.,1.)/16.,c=vec3(15.,.5,15.)/16.;
       r=d(v+n,v+c,f,x,i);
       m=m||r;
     }
   #endif
   #endif
   return m;
 }
 vec2 c(inout float v)
 {
   return fract(sin(vec2(v+=.1,v+=.1))*vec2(43758.5,22578.1));
 }
 float G(vec2 v)
 {
   v*=vec2(viewWidth,viewHeight);
   const float y=1.61803,x=1.32472;
   return fract(dot(v,1./vec2(y,x*x)));
 }
 vec3 D(vec2 v)
 {
   vec2 y=vec2(v.xy*vec2(viewWidth,viewHeight))/64.;
   const vec2 m[16]=vec2[16](vec2(-1,-1),vec2(0,-.333333),vec2(-.5,.333333),vec2(.5,-.777778),vec2(-.75,-.111111),vec2(.25,.555556),vec2(-.25,-.555556),vec2(.75,.111111),vec2(-.875,.777778),vec2(.125,-.925926),vec2(-.375,-.259259),vec2(.625,.407407),vec2(-.625,-.703704),vec2(.375,-.037037),vec2(-.125,.62963),vec2(.875,-.481482));
   if(v.x<2./viewWidth||v.x>1.-2./viewWidth||v.y<2./viewHeight||v.y>1.-2./viewHeight)
     ;
   else
      y+=m[int(mod(frameCounter,8.f))]*.5;
   y=(floor(y*64.)+.5)/64.;
   vec3 n=texture2D(noisetex,y).xyz;
   return n;
 }
 vec3 D(vec3 v,vec2 y)
 {
   y=y*.99+.005;
   #if GI_RESPONSIVENESS<1
   #endif
   float f=6.28319*y.x,x=sqrt(y.y);
   vec3 n=normalize(cross(v,vec3(0.,1.,1.))),c=cross(v,n),i=n*cos(f)*x+c*sin(f)*x+v.xyz*sqrt(1.-y.y);
   return i;
 }
 vec3 y(inout float v)
 {
   vec3 y=D(texcoord.xy).xyz;
   y=fract(y+vec3(c(v),c(v).x)*.1);
   y=y*2.-1.;
   y=normalize(y);
   return y;
 }
 vec3 G(vec3 v,vec3 y)
 {
   vec2 f=s(e(m(v)+y+1.+e()));
   vec3 n=g(f).JWRqQQkOhM;
   return n;
 }
 vec3 D()
 {
   vec2 y=s(v(texcoord.xy)+e()/d());
   vec3 n=g(y).JWRqQQkOhM;
   return n;
 }
 vec3 D(vec3 v,vec3 m,vec3 y,vec3 n,vec3 x,MaterialMask z,float s,vec2 r,float t,out float c)
 {
   float w=fract(frameCounter*.0123456),e=1.;
   #ifdef SUNLIGHT_LEAK_FIX
   if(isEyeInWater<1)
     e=saturate(s*100.);
   #endif
   float A=1.;
   #ifdef CAVE_GI_LEAK_FIX
   if(isEyeInWater<1)
     A=saturate(s*10.);
   #endif
   vec3 a=D(texcoord.xy+vec2(0.,0.)).xyz,h=D(n,a.xy);
   c=10000.;
   vec3 M=h;
   #ifdef GI_SCREEN_SPACE_TRACING
   bool g=false;
   {
     const int Y=5;
     float T=.25*-m.z;
     T=mix(T,.8,.5);
     float l=.07*-m.z;
     l=mix(l,1.,.5);
     l=.6;
     vec2 o=texcoord.xy;
     vec3 R=m.xyz,b=normalize((gbufferModelView*vec4(h.xyz,0.)).xyz);
     for(int S=0;S<Y;S++)
       {
         float W=float(S),k=(W+.5+a.z)/float(Y),F=T*k;
         vec3 C=m.xyz+b*F,P=ProjectBack(C),U=GetViewPositionNoJitter(P.xy,GetDepth(P.xy)).xyz;
         float H=length(C)-length(U)-.02;
         if(H>0.&&H<l)
           {
             g=true;
             o=P.xy;
             R=U.xyz;
             break;
           }
       }
     vec3 S=(gbufferModelViewInverse*vec4(R,1.)).xyz;
     S+=Fract01(cameraPosition.xyz+.5)+.5;
     if(g)
       {
         vec3 C=pow(texture2DLod(colortex7,o.xy-r*.5,0).xyz,vec3(2.2));
         C*=1.-saturate(t*1.1);
         return C*100.;
       }
   }
   #endif
   int o=f();
   float C=1./float(o);
   vec3 l=v+y*(.0001*length(v));
   l+=Fract01(cameraPosition.xyz+.5);
   Ray T=MakeRay(f(l,o)*o-vec3(1.,1.,1.),h);
   zdAtCTBXEz P=p(T);
   vec3 S=vec3(1.),R=vec3(0.);
   float W=0.,b=1.;
   {
     vec4 F=vec4(0.);
     vec3 Y=vec3(0.);
     float H=.5;
     for(int k=0;k<DIFFUSE_TRACE_LENGTH;k++)
       {
         Y=P.ipiiYVkNiW/float(o);
         vec2 U=d(Y,o);
         F=texture2DLod(shadowcolor,U,0);
         W=F.w*255.;
         float J=1.-step(.5,abs(W-241.));
         vec3 I=F.xyz;
         R+=I*J*H*.5;
         #ifdef GI_LEAF_TRANSPARENCY
         if(abs(W-36.)<.1)
           {
             if(a.z<pow(.2,b))
               {
                 i(P);
                 H=1.;
                 b+=1.;
                 S*=pow(F.xyz,vec3(.25));
                 continue;
               }
           }
         #endif
         if(W<240.)
           {
             if(d(P.ipiiYVkNiW,W,T,k==0,c,M))
               {
                 break;
               }
           }
         i(P);
         H=1.;
       }
     float k=0.;
     if(W<1.f||W>254.f)
       {
         vec3 U=T.direction;
         if(isEyeInWater>0)
           U=refract(U,vec3(0.,-1.,0.),1.3333);
         vec3 I=SkyShading(U,worldSunVector,rainStrength);
         I*=saturate(U.y*10.+1.);
         I=DoNightEyeAtNight(I*12.,timeMidnight)*.083333;
         I=TintUnderwaterDepth(I);
         if(length(U)<.1)
           k=300.;
         vec3 J=I*A*S;
         #ifdef CLOUDS_IN_GI
         CloudPlane(J,-T.direction,worldLightVector,colorSunlight,colorSkyUp,J,timeMidnight,false);
         #endif
         R+=J*.1;
       }
     else
       {
         if(abs(W-31.)<.1)
           R+=.09*S*F.xyz*GI_LIGHT_BLOCK_INTENSITY;
         if(W>=32.&&W<=35.)
           {
             float I=0.;
             if(abs(W-32.)<.1)
               I=max(-M.z,0.);
             if(abs(W-33.)<.1)
               I=max(M.x,0.);
             if(abs(W-34.)<.1)
               I=max(M.z,0.);
             if(abs(W-35.)<.1)
               I=max(-M.x,0.);
             R+=.04*S*I*vec3(2.,.35,.025)*GI_LIGHT_BLOCK_INTENSITY;
           }
         if(W<240.)
           {
             vec3 I=saturate(F.xyz);
             S*=I;
             R+=G(Y,M)*S*1.5;
             const float J=2.4;
             vec3 U=i(l+T.direction*c-1.,worldLightVector,M,h,o),u=DoNightEyeAtNight(U*S*J*colorSunlight*e*A*12.,timeMidnight)/12.;
             R+=u;
             k=c;
           }
       }
     UnderwaterFog(R,k,h,colorSkyUp,colorSunlight);
   }
   if(z.grass<.5)
     R/=saturate(dot(n,h))+.01,R*=saturate(dot(y,h));
   return R;
 }
 vec3 G()
 {
   int y=f();
   vec3 x=v(texcoord.xy),m=n(x),c=f(m-vec3(1.,1.,0.),y);
   vec2 r=d(c,y);
   float s=1.;
   #ifdef CAVE_GI_LEAK_FIX
   if(isEyeInWater<1)
     s*=saturate(eyeBrightnessSmooth.y/240.*20.);
   #endif
   float z=1000.;
   z=min(z,texture2DLod(shadowcolor,d(f(m-vec3(0.,0.,0.),y),y)+vec2(.5,.5)/float(4096),0).w);
   z=min(z,texture2DLod(shadowcolor,d(f(m-vec3(0.,0.,0.),y),y)+vec2(-.5,-.5)/float(4096),0).w);
   z=min(z,texture2DLod(shadowcolor,d(f(m-vec3(0.,1.,0.),y),y)+vec2(0.,0.)/float(4096),0).w);
   z=min(z,texture2DLod(shadowcolor,d(f(m-vec3(0.,-1.,0.),y),y)+vec2(0.,0.)/float(4096),0).w);
   float t=texture2DLod(shadowcolor,d(f(m-vec3(0.,0.,0.),y),y),0).w;
   if(z*255.>240.||t*255.<240.)
     return vec3(0.);
   vec3 w=vec3(0.);
   for(int e=0;e<GI_SECONDARY_SAMPLES;e++)
     {
       float a=sin(frameTimeCounter*1.1)+m.x*.11+m.y*.12+m.z*.13+e*.1;
       vec3 h=normalize(rand(vec2(a))*2.-1.);
       h.x+=h.x==h.y||h.x==h.z?.01:0.;
       h.y+=h.y==h.z?.01:0.;
       vec3 W=m+vec3(1.,1.,1.);
       Ray o=MakeRay(f(W,y)*y-vec3(1.,1.,1.),h);
       zdAtCTBXEz M=p(o);
       vec3 S=vec3(1.);
       float I=1000.;
       for(int R=0;R<1;R++)
         {
           vec4 g=vec4(0.);
           float l=0.;
           vec3 U=vec3(0.);
           float C=.2;
           for(int k=0;k<DIFFUSE_TRACE_LENGTH;k++)
             {
               U=M.ipiiYVkNiW/float(y);
               vec2 J=d(U,y);
               g=texture2DLod(shadowcolor,J,0);
               l=g.w*255.;
               float A=1.-step(.5,abs(l-241.));
               vec3 T=g.xyz;
               w+=T*C*A*(k==0?.5:1.);
               if(l<240.)
                 {
                   break;
                 }
               i(M);
               C=saturate(C*1.3);
             }
           I=distance(M.ipiiYVkNiW.xyz,M.ipiiYVkNiWOrigin.xyz);
           float k=0.,A=1.;
           if(abs(M.ipiiYVkNiW.x-M.ipiiYVkNiWOrigin.x)<2||abs(M.ipiiYVkNiW.y-M.ipiiYVkNiWOrigin.y)<2||abs(M.ipiiYVkNiW.z-M.ipiiYVkNiWOrigin.z)<2)
             A=0.;
           if(l<1.f||l>254.f)
             {
               vec3 T=o.direction;
               if(isEyeInWater>0)
                 T=refract(T,vec3(0.,-1.,0.),1.3333);
               vec3 F=SkyShading(T,worldSunVector,rainStrength);
               F*=saturate(T.y*10.+1.);
               F=DoNightEyeAtNight(F*12.,timeMidnight)*.083333;
               F=TintUnderwaterDepth(F);
               if(isEyeInWater>0)
                 ;
               if(length(T)<.1)
                 k=300.;
               vec3 J=F*s*S;
               CloudPlane(J,-o.direction,worldLightVector,colorSunlight,colorSkyUp,J,timeMidnight,false);
               w+=J*.1;
             }
           vec3 T=-M.HXMzbpgVIA*M.DagoLvaZQG;
           if(abs(l-31.)<.1)
             w+=.09*g.xyz*GI_LIGHT_BLOCK_INTENSITY;
           if(l>=32.&&l<=35.)
             {
               float J=0.;
               if(abs(l-32.)<.1)
                 J=max(-T.z,0.);
               if(abs(l-33.)<.1)
                 J=max(T.x,0.);
               if(abs(l-34.)<.1)
                 J=max(T.z,0.);
               if(abs(l-35.)<.1)
                 J=max(-T.x,0.);
               w+=.02*S*J*vec3(2.,.35,.025)*GI_LIGHT_BLOCK_INTENSITY;
             }
           if(l<240.)
             {
               vec3 J=saturate(g.xyz);
               S*=J;
               vec3 F=-(M.HXMzbpgVIA*M.DagoLvaZQG);
               const float H=2.4;
               vec3 Y=f(U,worldLightVector,F,h,y),P=DoNightEyeAtNight(Y*H*colorSunlight*A*S*s*12.,timeMidnight)/12.;
               w+=P*2.;
               w+=G(U,F)*S;
               k=I;
             }
           {
             vec2 J=IntersectSphere(m,o.direction,vec3(0.,1.5,0.),.75);
             if(I>J.y&&J.y>-.5)
               ;
           }
           UnderwaterFog(w,k,h,colorSkyUp,colorSunlight);
         }
     }
   w/=float(GI_SECONDARY_SAMPLES);
   return saturate(w);
 }
 vec4 T(float v)
 {
   float y=v*v,m=y*v;
   vec4 f;
   f.x=-m+3*y-3*v+1;
   f.y=3*m-6*y+4;
   f.z=-3*m+3*y+3*v+1;
   f.w=m;
   return f/6.f;
 }
 vec4 T(in sampler2D v,in vec2 y)
 {
   vec2 f=vec2(viewWidth,viewHeight);
   y*=f;
   y-=.5;
   float m=fract(y.x),i=fract(y.y);
   y.x-=m;
   y.y-=i;
   vec4 n=T(m),c=T(i),x=vec4(y.x-.5,y.x+1.5,y.y-.5,y.y+1.5),s=vec4(n.x+n.y,n.z+n.w,c.x+c.y,c.z+c.w),r=x+vec4(n.y,n.w,c.y,c.w)/s,z=texture2DLod(v,vec2(r.x,r.z)/f,0),t=texture2DLod(v,vec2(r.y,r.z)/f,0),w=texture2DLod(v,vec2(r.x,r.w)/f,0),h=texture2DLod(v,vec2(r.y,r.w)/f,0);
   float o=s.x/(s.x+s.y),k=s.z/(s.z+s.w);
   return mix(mix(h,w,o),mix(t,z,o),k);
 }
 bool c(vec3 v,vec3 y)
 {
   vec3 n=normalize(cross(dFdx(v),dFdy(v))),i=normalize(y-v),c=normalize(i);
   float f=.02+length(v)*.04;
   return distance(v,y)<f;
 }
 vec3 F(vec2 v)
 {
   vec2 y=vec2(viewWidth,viewHeight),m=1./y,f=v*y,x=floor(f-.5)+.5,n=f-x,z=n*n,c=n*z;
   float s=.5;
   vec2 i=-s*c+2.*s*z-s*n,r=(2.-s)*c-(3.-s)*z+1.,t=-(2.-s)*c+(3.-2.*s)*z+s*n,M=s*c-s*z,w=r+t,a=m*(x+t/w);
   vec3 l=texture2DLod(colortex4,vec2(a.x,a.y),0).xyz;
   vec2 o=m*(x-1.),h=m*(x+2.);
   vec4 J=vec4(texture2DLod(colortex4,vec2(a.x,o.y),0).xyz,1.)*(w.x*i.y)+vec4(texture2DLod(colortex4,vec2(o.x,a.y),0).xyz,1.)*(i.x*w.y)+vec4(l,1.)*(w.x*w.y)+vec4(texture2DLod(colortex4,vec2(h.x,a.y),0).xyz,1.)*(M.x*w.y)+vec4(texture2DLod(colortex4,vec2(a.x,h.y),0).xyz,1.)*(w.x*M.y);
   return max(vec3(0.),J.xyz*(1./J.w));
 }
 vec2 D(float v,vec2 f,out float y,out vec3 n,out vec4 i)
 {
   float x;
   vec2 c=GetNearFragment(texcoord.xy,v,x);
   y=texture2D(depthtex1,c).x;
   vec4 m=vec4(texcoord.xy*2.-1.,y*2.-1.,1.),r=gbufferProjectionInverse*m;
   r.xyz/=r.w;
   vec4 s=gbufferModelViewInverse*vec4(r.xyz,1.);
   i=s;
   i.xyz+=cameraPosition-previousCameraPosition;
   vec4 t=gbufferPreviousModelView*vec4(i.xyz,1.),w=gbufferPreviousProjection*vec4(t.xyz,1.);
   w.xyz/=w.w;
   n=m.xyz-w.xyz;
   float z=length(n.xy)*10.,o=clamp(z*500.,0.,1.);
   vec2 J=f.xy-n.xy*.5;
   if(y<.7)
     J=texcoord.xy;
   return J;
 }
 void main()
 {
   GBufferData v=GetGBufferData();
   MaterialMask y=CalculateMasks(v.materialID);
   vec4 f=GetViewPosition(texcoord.xy,v.depth),n=gbufferModelViewInverse*vec4(f.xyz,1.),i=gbufferModelViewInverse*vec4(f.xyz,0.);
   vec3 x=normalize(f.xyz),m=normalize(i.xyz),r=normalize((gbufferModelViewInverse*vec4(v.normal,0.)).xyz),z=normalize((gbufferModelViewInverse*vec4(v.geoNormal,0.)).xyz);
   float s=length(f.xyz),t=dot(v.mcLightmap.xy,vec2(.5));
   if(y.grass>.5)
     r=vec3(0.,1.,0.),z=vec3(0.,1.,0.);
   vec4 w=vec4(texcoord.xy,0.,0.);
   float a;
   vec3 M;
   vec4 o;
   vec2 T=D(v.depth,w.xy,a,M,o),l=T.xy;
   l-=(vec2(mod(frameCounter/2,2.f),mod(frameCounter,2.f))-.5)/vec2(viewWidth,viewHeight)*1.5;
   vec3 J=F(l.xy);
   veHQsJlbTL k=g(T.xy);
   float W=1./(saturate(-dot(v.geoNormal,x))*100.+1.);
   vec4 U=vec4(T.xy,0.,0.);
   TemporalJitterProjPosPrevInv(U);
   vec4 I=gbufferPreviousProjectionInverse*vec4(T.xy*2.-1.,texture2DLod(colortex7,U.xy,0).w*2.-1.,1.);
   I/=I.w;
   vec3 R=(gbufferPreviousModelViewInverse*vec4(I.xyz,1.)).xyz;
   k.nnNEIJGkdr+=1.;
   k.nnNEIJGkdr=min(k.nnNEIJGkdr,2.);
   vec2 e=1./vec2(viewWidth,viewHeight),d=1.-e;
   float C=0.,A=1.-exp2(-k.nnNEIJGkdr);
   if(!c(o.xyz,R.xyz)||(T.x<e.x||T.x>d.x||T.y<e.y||T.y>d.y)||abs(W-k.ofqplrivFA)>.01)
     A=0.,C=.99,k.nnNEIJGkdr=0.;
   float S;
   vec3 Y=D(n.xyz,f.xyz,r.xyz,z,m.xyz,y,v.mcLightmap.y,M.xy,C,S);
   Y=max(vec3(0.),Y);
   Y=mix(Y,J,vec3(A));
   C=max(C,mix(C,.9,saturate(-M.z*120.)));
   k.ofqplrivFA=W;
   k.WMbBZukiRr=mix(k.WMbBZukiRr,C,mix(.5,1.,C));
   k.KFTSJGnGnw=t;
   vec3 H=G();
   k.JWRqQQkOhM=mix(D(),H,vec3(.015));
   vec4 P=h(k);
   gl_FragData[0]=vec4(Y,saturate(a));
   gl_FragData[1]=vec4(P);
   gl_FragData[2]=vec4(Y,1.);
 };




/* DRAWBUFFERS:456 */
